-- 读表工具
JsonTools = {}
JsonTools.buffer_ = {}


JsonTools.PRINT_FLAG = true or false;
-- 初始化所有json表
function JsonTools:InitJson ()
	--返回json的路径位置
	--logError("JsonStartTime"..Time.time)

    
    
    -- JsonTools:PrintJsonSta();
--这里 需要建一个jsonSystem的表 明天来吧
    local data = self:GetJson (JsonConstant.TB_Z_CLIENT_JSON_SYSTEM)
    local dataArray = data["RECORDS"]
    JsonManage:PutData (dataArray, "json number" .. table.maxn (dataArray), JsonConstant.TB_Z_CLIENT_JSON_SYSTEM)
    item = JsonManage:GetTableItemOfName (JsonConstant.TB_Z_CLIENT_JSON_SYSTEM)
--    print("共有" ..#item:GetJsonTable() .."个表")
    for	k, v in pairs (item:GetJsonTable ()) do
		--获得json的路径
        
		--传入路径 返回数据
        --logError("第"..k.."是"..v.jsonName)
        data = self:GetJson (v.jsonName)
        if(data~=nil) then
            dataArray = data["RECORDS"]

            --print("print  ".. v.jsonKey)
            JsonManage:PutData (dataArray, v.jsonKey, v.jsonName)
        end
		
--下面是一个读取 jsonKey的表 是有重复记录的 样子
--		---- if(v.jsonKey == "architecture_type") then
--			for k,v in pairs(dataArray) do
--				logError(k..":")
--				logError(v==nil);
--				for tk,tv in pairs(v) do
--					logError(tk..":"..tv)
--				end
--				
--			end
--			
--		end
		
    end

    --logError("JsonEndTime"..Time.time)
end

-- 传入路劲返回json数据
function JsonTools:GetJson (jsonName)
    --logError("读取Json：" .. jsonName)
    local path = self:GetJsonPath (jsonName)
    local text = nil
    if(Lua_GzLog.LOG_INIT_JSON) then
        logError("JsonTools:GetJson 默认为 c:/下  ".. path);
    end
    --logError("appconst.updatemode")
    --logError(AppConst.UpdateMode)
    local file = nil
    if(AppConst.UpdateMode == true) then
        file = io.open(path, "r")
        if(Lua_GzLog.LOG_INIT_JSON) then
            logError("hotupdate模式 路径"..path)
        end 
     end
     if(file==nil ) then
        if(Lua_GzLog.LOG_INIT_JSON) then
            logError("GetJsonPath 热更地址文件不存在" );
        end     
        --logError(jsonName)

        



        text = FileTools.LoadJsonToText(jsonName);
        if(text == nil) then
            if(Lua_GzLog.LOG_INIT_JSON) then
                logError("表在AndroidRes中并不存在 请build json")
            end

            
            if(Util.IsUnity()) then  
                logError("如果是电脑运行")
                path = self:GetJsonLocalPath(jsonName)
                file = io.open(path, "r")
                if(file~=nil) then
                    file:close()
                    --logError("文件存在");
                    --logError("util==nil")
                    text = tools_CjsonUtil.file_load(path)
                    logError("表"..jsonName.."在合法的位置不存在 但因为是在unity下运行 可以在本地直接读取" .. path)
                    if(text == nil) then
                        logError("在本地代码位置的json目录还是没有读到");
                    else
                        logError("在本地代码位置读取json文件")
                    end
                    
                else
                    logError("电脑中也不存在表"..jsonName.."你他妈想干啥")
                end
            end
        end


     else
        if(Lua_GzLog.LOG_INIT_JSON) then
            logError("file 文件在"..path.."读取时不为空")
        end
        file:close()
        --logError("文件存在");
        --logError("util==nil")
        text = tools_CjsonUtil.file_load(path)
        --logError("读取完成")
        -- logError(text)
       
     end
    
    if(text == nil) then
        if(Lua_GzLog.LOG_INIT_JSON) then
            logError("表"..jsonName.."不存在 请检查JsonData是否存在")
        end
        --logError("表"..jsonName.."不存在 请检查JsonData是否存在")
        --logError("表"..jsonName.."不存在 请检查JsonData是否存在")
        --logError("表"..jsonName.."不存在 请检查JsonData是否存在")

        --return nil
    end

    
  --  print(text)

    local obj = tools_Cjson.decode (text)
    return obj
end

--json path-data对象池
function JsonTools:GetBufferJson(path)
    -- 检查是否读过
    --print("GetBufferJson:"..path)
    if nil == JsonTools.buffer_[path] then
        --读取数据
        --local path_ = JsonTools:GetJsonPath(path)  
        --print("load json from file:"..path_)
		--TODO: 优化读json表方式，读表的时候设置好key
		local jsonTable = JsonTools:GetJson(path)
        JsonTools.buffer_[path] = jsonTable["RECORDS"]
    end
    return JsonTools.buffer_[path]
end


-- 传入表名返回路径拼接 获得热更地址        热更地址是外部地址 c:/的
function JsonTools:GetJsonPath (jsonName)
    local path = '';

    path = Util.DataPath

    --logError("GetJson"..jsonName)

    --logError("path = "..path)

    if(UnityEngine.Application.isMobilePlatform == false and GzHotUpdateConst.Simulation_Phone == 0) then
        -- 如果是编辑器 且 不是模拟 可以返回 本地路径   注意 这里 Simulation_Phone 虽然是bool 但在这里只能用0 判断  而 isMobilePlatform 为什么可以用bool方式 是因为 他是一个属生 而不是 值
        --参见 UnityEngine_ApplicationWrap  的 L.RegVar("isMobilePlatform", get_isMobilePlatform, null); 而 AppConst的是 L.RegConstant("Simulation_Phone", 0);
        path = AppConst.FrameworkRoot
        -- logError(path)
        path = path .. "/"
         logError("从本地查找")
    end
	--print("path----------"..path)
--[[ 
    原代码 
    热更时 或是 移动平台时 从热列地址 DataPath返回  不热更 移动平台为什么可行呢？是因为之前会复制文件到热更地址，但同在不再复制文件了 所以不能这样了
    非热更时， 苹果因为从本地读 所以返回本地地址
            

    if(Util.IsIphone() and AppConst.UpdateMode == 0  ) then
        --logError("如果是苹果的话 先从内部读下")
        path = Util.AppContentPath()
    else
        if AppConst.UpdateMode == 1 or UnityEngine.Application.isMobilePlatform then        
            --logError("是热更状态 或是 移动状态")

            --如果是热更状态 或 打包状态 
            --返回 Util.DataPath 位置  数据存储的位置
            
            --这里 不能这样用 看看有没有别的判断吧 不是util 或者 先强制写成 iphone的 用于测试
            --util 是因为没保存上 明天再试一下 加下 isphone的方法
            --等一切都完事了 试试真正的热更 看是不是好的
            

                path = Util.DataPath
            
        else
            --logError("不是热更状态 也不是 移动状态")
            --本地luaframe /lua/jsondata的位置
            path = Util.AppContentPath()
        end
    end
]]
    
--    print(path .. "lua/JsonData/" .. jsonName .. ".json")
    return  path .. "lua/JsonData/" .. jsonName .. ".json"
end

-- 获得代码
function JsonTools:GetJsonLocalPath(jsonName)
    return  AppConst.FrameworkRoot .. "/lua/JsonData/" .. jsonName .. ".json"
end




--输出一下表名的内容
function JsonTools:PrintTable(jsonName)
    local jsonItem = JsonManage:GetTableItemOfName(jsonName)
    if(jsonItem == nil) then
        logError("表"..jsonName.."不存在")
    else
        logError("表"..jsonName.."存在")

        logError(jsonItem:GetJsonKey())

        local jsonList = jsonItem:GetJsonTable()

        for k,v in pairs(jsonList) do
            print("主键"..k)
            for k1,v1 in pairs(v) do
                print("     子项 字段"..k1.."值"..v1)
            end
        end
        

        --LuaPrintTools.PrintTable(jsonItem:GetJsonTable())
    end

end

function JsonTools:PrintJsonSta()
    local sb = StringBuffer.New()
    sb:Append("Json读取设置")

    if(GzHotUpdateConst.Simulation_Phone) then
        sb:Append("模拟手机")
    else
        sb:Append("非模拟手机")
    end
    if(UnityEngine.Application.isMobilePlatform) then
        sb:Append("手机")
    else
        sb:Append("非手机")
    end
    if(UnityEngine.Application.isMobilePlatform == false and GzHotUpdateConst.Simulation_Phone == 0) then
        sb:Append("当前不是 手机模式 也不是 模拟手机模式")
        sb:Append("通过JsonTools:GetJsonPath方法 从 AppConst.FrameworkRoot里读取 : " .. AppConst.FrameworkRoot)
    else
        sb:Append("当前是手机 或是模拟手机模式 从 Util.DataPath 读取 :" .. Util.DataPath)
    end
    local path = JsonTools:GetJsonPath("X的文件名")
    sb:Append("最终是"..path)
    if(AppConst.UpdateMode == true) then
        sb:Append("热更模式 先从path 读取")
    else
    end
    sb:Append("如未读取 准备从本地读取")
    logError(sb:GetMessageStr())
end

--return JsonTools

