--主导入 不论哪个项目 都要有的流程


Main_Package={}


Main_Package.mainPath = "lua_client/"
Main_Package.theProjectPath = Main_Package.mainPath .."the_project/"
Main_Package.mainProjectPath = Main_Package.mainPath .."project_main/"

function InitMainPackage()
    -- require "lua_client/project_main/package_logic/Combo_file_tools"
    
end
function InitSubPackage()
   require "lua_client/project_main/package_logic/Sub_Package"
   
      Sub_Package.requireAllPackage()

    -- 初始化json  表
      JsonTools:InitJson ()  
      QuestTaskDicSystem:InitData()
      PetDataDicSystem:InitData()
      Lua_LanguageManager.InitData()
    
end




-- 导入主流程
function Main_Package.RequireLogic()
    

    InitMainPackage()       -- 如果用 combo的方式  那这个还要执行吗???

    if (PackageLuaType == PLT_OLD_ALL_FILE) then
        logError("以 所有lua文件 单独读取方式")
        Main_Package.RequireLogicOf_All_Lua()
    else
        logError("以 combo all 整合的方式读取")
        Main_Package.RequireLogicOf_Combo_Lua()
    end
        
end


-- 初始化工具
function InitTools()
    
    for var = 1, #ToolsPath do
        -- print("ToolsPath[var]"..ToolsPath[var])
         require (Main_Package.mainProjectPath .. ToolsPath[var])
    end    
end

ToolsPath = {
    
        "client_tools/MathTools",
        "client_tools/TimeTools",
        "client_tools/JsonBuffer",
        "client_tools/JsonTools",
        "client_tools/ListTools",
        "JsonManage/JsonConstant",
        "JsonManage/ABS_JsonItem",
        "JsonManage/JsonItem",
        "JsonManage/JsonManage",
        "client_tools/LuaPrintTools", --用于输出表内容的工具
        "client_tools/UnityTools", --unity工具
        "client_tools/LogFlag", --log标记
        "client_tools/LuaTools", --lua工具
        "client_tools/GUITools", --GUI工具
        "client_tools/FriendChatTools",--聊天 IO 工具
        "client_tools/StringTools",--聊天 IO 工具
        "client_tools/LuaBaseUI", --baseUI
}


function Main_Package.RequireDefaultTools()
    tools_Cjson = nil
    if tools_Cjson == nil then
        tools_Cjson = require "cjson"
    end
    -- cjsonUtil 工具索引  这个要保留 因为所有调 util.file_load的util 都是用loack 定义的
    tools_CjsonUtil = nil
    if tools_CjsonUtil == nil then
        tools_CjsonUtil = require "3rd/cjson/util"
    end
end

function Main_Package.RequireLogicOf_All_Lua()

    -- 导入初始工具
    Main_Package.RequireDefaultTools()

    --初始化导入
    InitTools()
    
    
    
    --初始化 子项目导入
    InitSubPackage()

end

-- 这个combo 的操作 为什么在lua中做,而不是在c# 中做的原因 是因为要导入的所有文件 肯定是要用lua写一遍的
-- 如果在c#中做的话,需要再同步在c#中一遍,比较麻烦 
function Main_Package.RequireLogicOf_Combo_Lua()
    -- 导入初始工具
    Main_Package.RequireDefaultTools()

    require(Main_Package.mainProjectPath .. "package_logic/ComboLuaPackage")
end
