-- 子导入 针对不同的项目

Sub_Package={}

require (Main_Package.theProjectPath.."example_package/Example_Package")

require (Main_Package.theProjectPath.."notice/UINoticePanel")


require (Main_Package.theProjectPath.."language_manager/Lua_LanguageManager")

require (Main_Package.theProjectPath.."channel/ChannelManager")

-- 导入一个 相对 Main_Package.theProjectPath 的路径下的路径 及名字
function Sub_Package.requireClass(path, name)
    local Str = path.."/"..name; 
    Str = string.gsub(Str,"//","/");
	require(Str)
end



--导入某个组
function Sub_Package.requireLogic(item)
    for i,itemName in ipairs(item.itemList) do
        Sub_Package.requireClass(item.itemPath,itemName)
    end
end


-- 导入所有
function Sub_Package.requireAllPackage()
	for i, pv in ipairs(Sub_Package.packageList) do
		--print("pv.nameList.count"..#pv.nameList)
		Sub_Package.requireLogic(pv);
	end
end





-- 这里是一个组的内容  整个包会有N个组
QualifyReward_Package = {
    itemList={
        "QualifyRewardPanel",
        "QualifyRewardDataManager",
        "QualifyRewardVarDataManager",
        "QualifyRewardUiItem",
    },
    -- 相于对 Main_Package.theProjectPath 后的路径
    itemPath = Main_Package.theProjectPath.."QualifyReward"
}
--常量
Const_Package = {
    itemList={
       "Lua_ActivityConst",--活动常量
       "HeadBorderConst",  --头像框常量
       "ProductConst",  --商品常量
       "TalkingDataConst",--事件常量
    },
    -- 相于对 Main_Package.theProjectPath 后的路径
    itemPath = Main_Package.theProjectPath.."Const";
}

ViewPanel_Package = {
    itemList ={
        "LoginPanel",
        "ViewQuestPanel",
        "QuestTaskDicItem",
        "QuestTaskDicSystem",
        "TaskFunctionData",
    },
   itemPath =  Main_Package.theProjectPath.."TaskFunction"
}
LanguageManagerPackage = {
    itemList = {
        "Lua_LanguageManager",
    },
    itemPath =  Main_Package.theProjectPath.."language_manager"
}
--选择头像框
SelectHeadBorder_Package = {
    itemList={
       "SelectHeadBorderPanel",--选择头像框面板
       "HeadBorderUiItem",     --头像框uiitem
       "HeadBorderData",       --头像框数据
       "HeadBorderDataManager" --所有头像框数据管理器       
    },
    -- 相于对 Main_Package.theProjectPath 后的路径
    itemPath = Main_Package.theProjectPath.."SelectHeadBorder";
}
GzTools_Package = {
    itemList={
       "Lua_GzDebug",--开关配置
       "Lua_GzLog",--日志开关
    },
    -- 相于对 Main_Package.theProjectPath 后的路径
    itemPath = Main_Package.theProjectPath.."GzTools";
}
Protocal_Package = {
    itemList={
       "InitDataProtocalManager",--刚进游戏初始化游戏相关协议
    },
    -- 相于对 Main_Package.theProjectPath 后的路径
    itemPath = Main_Package.theProjectPath.."Protocal";
}
Advertise_Package = {
    itemList={
       "Lua_AdsManager",--广告
    },
    -- 相于对 Main_Package.theProjectPath 后的路径
    itemPath = Main_Package.theProjectPath.."Advertise";
}
Pet_Package = 
{
    itemList = {
        "PetDataDicSystem",
        "ChoosePetPanel",
        "PetDataDicItem",
        "ViewPetHeadItem",
        
    },
    --相于对 Main_Package.theProjectPath 后的路径
    itemPath = Main_Package.theProjectPath.."PetFunction"
}
MoveUser_Package = {
    itemList = {
        "MoveUserPanel",
        "UserMoveData",
    },
    itemPath = Main_Package.theProjectPath.."userMoveFunction"
}
Rotary_package = {
    itemList = {
        "RotaryPanel",
        "RotaryItemData",
        "RotaryConst",
    },
    itemPath = Main_Package.theProjectPath.."Rotary"
}
Promotion_Package = {
    itemList = {
        "PromotionPanel",
        "PromotionItemSystem",
        "PromotionItemData",
    },
    itemPath = Main_Package.theProjectPath.."ShopPromotion"
}
--这里是所有的组
Sub_Package.packageList = 
{
    QualifyReward_Package,
    Const_Package,
    ViewPanel_Package,
    LanguageManagerPackage,
    SelectHeadBorder_Package,
    GzTools_Package,
    Protocal_Package,
    Advertise_Package,
    Pet_Package,
    MoveUser_Package,
    Rotary_package,
    Promotion_Package,
}
