﻿--小跟班的常量管理項
PetDataDicItem ={}

function PetDataDicItem.New()
    local item = {}
    setmetatable(item, PetDataDicItem)
    PetDataDicItem.__index = PetDataDicItem
    --小跟班的 id
    item.petId =0
    --小跟班的技能id
    item.skillId = 0
    -- 小跟班的名字
    item.petName = ""
    -- 小跟班的模型名字
    item.petModleName = ""
    --小跟班的头像
    item.petHeadSp = ""
    --小跟班的模型部分 UI显示 需要用到 关于 模型 和UI 层级的问题解决
    item.petBadyName = ""

    item.petRare="" --小跟班的 R SR SSR

    --碎片常量
    item.pieceId=0  --碎片道具ID
    item.pieceComboNum =0   --合成所需数量
    --小跟班的体力
    item.power = 0
    --小跟班最大体力
    item.petPowerMax = 0
    --- 变量代码部分

    item.isLock=true;--锁定
    return item 

end
--获得当前的Key
function PetDataDicItem:GetKey()
    return self.petId
end 
--获得小跟的技能
function PetDataDicItem:GetSkillId()
    return self.skillId
end 
--获得模型的 名字
function PetDataDicItem:GetModelName()
    return self.petModleName
end 
--获得小跟班的名字
function PetDataDicItem:GetPetName()
    return self.petName
end 
function PetDataDicItem:ClearLock()
    self.isLock=false
end

function PetDataDicItem:IsUnLock()
    return self.isLock==false;
end
function PetDataDicItem:IsLock()
    return self.isLock;
end
--获得碎片个数 
function PetDataDicItem:GetPetPieceCount()

    return PropVarDataManger.Instance:GetPropVarCountOfPropId(self.pieceId)
end
