﻿InitDataProtocalManager = {};

--刷新任务
InitDataProtocalManager.PROTOCOL_274=274;

--InitDataProtocalManager.releaseVer = 2019061800
--InitDataProtocalManager.releaseVer = 2019121200 -- 商城,buff
InitDataProtocalManager.releaseVer = 2020011000 
-- 2019050100 51版本      --2019060700 61版本
function  InitDataProtocalManager.GetReleaseVer()

    return InitDataProtocalManager.releaseVer
end 
--10协议后调用的接口
function InitDataProtocalManager.SyncUserDataEnd10Pro()
    if(Lua_GzLog.LOG_PROTOCOL) then
        logError("调用10协议后的lua接口")
    end
end

--40协议前调用的接口
function InitDataProtocalManager.SyncUserDataBefore40Pro()
    if(Lua_GzLog.LOG_PROTOCOL) then
        logError("调用40协议前的lua接口")
    end
    InitDataProtocalManager.SyncUserData();
end
--40协议后调用的接口
function InitDataProtocalManager.SyncUserDataEnd40Pro()
    if(Lua_GzLog.LOG_PROTOCOL) then
        logError("调用40协议后的lua接口")    
    end
end


--发送272协议同步数据 
function InitDataProtocalManager.SyncUserData()
    if(Lua_GzLog.LOG_PROTOCOL) then
        logError("发送272  lua！！！！！！！！！！！！！！！！！！！！！！！！！！！！")
    end
    local taskType = NetConfig.HttpTaskType.HttpTaskType_Sync_Data_Lua;
    local param = JsonObject.New();
    param:encode("","");
    local luaClass = "InitDataProtocalManager"
    local luaFun = "SyncDataCallBack"
    GzNet.Call(taskType,param,luaClass,luaFun)    
end

function InitDataProtocalManager.SyncDataCallBack(netData)
    if(netData) then    
        if(netData._data) then
            --logError("数据！！！！！！！！！！！！！！！！！！！！！！！"..netData._data);
            local callBackStr = netData._data;     
            local callBackDatas = tools_Cjson.decode (callBackStr); 
            if(callBackDatas.code == 0) then
            --协议数据
             local protocolData= callBackDatas.data;
              --赋值头像框解锁数据
                local headList = protocolData.headList;
                HeadBorderDataManager:GetBorderDataByPro(headList) 
                HeadBorderDataManager.isFirstRechargeHead = protocolData.isFirstRechargeHead                                                            
              --赋值赛季奖励数据               
                --奖励数据
                local rewardList = protocolData.rewardList;                
                --赛季累计星星
                QualifyRewardVarDataManager:SetStarNum(protocolData.starProcess); 
                --设置赛季奖励数据
                QualifyRewardVarDataManager:GetRewardDataByPro(rewardList); 
                --设置当前是第几赛季
                QualifyRewardVarDataManager:SetSeasonNum(protocolData.seasonNum);
                -- print("protocolData.seasonNumprotocolData.seasonNumprotocolData.seasonNum"..protocolData.seasonNum)
                if(protocolData.petList ~= nil) then
                    -- 如果宝宝数据存在的话
                 --   print("protocolData.petListprotocolData.petListprotocolData.petList==="..protocolData.petList)
                    print(protocolData.petList == nil)
                    for k,v in pairs(protocolData.petList) do
                        local petItem = PetDataDicSystem:GetPetDicItemOfId(tonumber(v.petId))
                        petItem:ClearLock()
                        petItem.power = v.petPower
                    end
                    -- local petListStr = protocolData.petList
                    -- if petListStr ~="" then
                    --     -- body
                    --     local petLstData = string.split(petListStr,",");
                    --     for k,v in pairs(petLstData) do 
        
                    --         local petItem = PetDataDicSystem:GetPetDicItemOfId(tonumber(v))
                    --         petItem:ClearLock()
                    --     end 
                    -- end
                end
                if protocolData.foodPairList ~= nil  then
                    for i=1,# protocolData.foodPairList do
                      --print("  protocolData.foodPairList[i]======================="..  protocolData.foodPairList[i])
                      if i == 1  then
                            PetDataDicSystem.getPowerStr  =  protocolData.foodPairList[i]
                      else  
                        PetDataDicSystem.getPowerStr  =   PetDataDicSystem.getPowerStr ..",".. protocolData.foodPairList[i]
                      end
                     
                    end
                end
                UserMoveData.passwordFlag  = protocolData.passwordFlag
                print("protocolData.passwordFlagprotocolData.passwordFlag======"..protocolData.passwordFlag)
                UserMoveData.tansferTime = protocolData.tansferTime
                UserMoveData.protectQuestion = protocolData.protectQuestion


                --logError("当天剩余可看广告拿奖励次数为")
                --logError(protocolData.battleRewardRemaining)
                if protocolData.battleRewardRemaining==nil then
                    GzGameOver.Instance().battleRewardRemaining =0
                else
                    --logError("当天剩余可看广告拿奖励次数为".. protocolData.battleRewardRemaining)
                    GzGameOver.Instance().battleRewardRemaining = protocolData.battleRewardRemaining

                    --logError("当天剩余可看广告拿奖励次数变量为".. GzGameOver.Instance().battleRewardRemaining)
                end
                --商城数据获取
                if protocolData.timeLimitShopList ~= nil then
                    local timeLimitShopList = protocolData.timeLimitShopList                    
                    local dayItemCount = 0
                    local discountItemCount = 0
                    for k,v in pairs(timeLimitShopList) do
                        local itemInfo = string.split(v.rewardStr,':') 
                        local prItem = PromotionItemData.New()
                        prItem.id = v.id
                        prItem.type = v.type

                        if v.type == PromotionItemSystem.DISCOUNT_ITEM_TYPE then
                            discountItemCount = discountItemCount + 1
                            prItem.index = discountItemCount
                        elseif v.type == PromotionItemSystem.DAY_ITEM_TYPE then
                            dayItemCount = dayItemCount + 1
                            prItem.index = dayItemCount
                        elseif v.type == PromotionItemSystem.BOX_ITEM_TYPE then 
                            prItem.index = 1
                            getBoxItem = true
                        else
                            prItem.index = 1
                        end
                        --prItem.index = key
                        prItem.propId = itemInfo[1]
                        if v.type == PromotionItemSystem.BOX_ITEM_TYPE then 
                            prItem.propNum = 1
                        else
                            prItem.propNum = tonumber(itemInfo[2]) 
                        end
                        prItem.cost = v.cost
                        prItem.costPropId = v.costPropId
                        prItem.status = v.status
                        prItem.refreshCountdown = v.refreshCountdown
                        prItem.beforeCost = v.beforeCost
                        PromotionPanel.countDownTime = v.refreshCountdown
                        table.insert(PromotionItemSystem.allItems,prItem) 
                        -- PromotionItemSystem.costBoxItem = v
                    end
                end
                --同步数据完成，刷新当前同步状态
                InitDataProtocalManager.GetSyncCallBackSuccess("272");
            end
        end    
    end   
end

--用来同步数据的协议表
InitDataProtocalManager.SyncProtocolList ={
    protocol40 = false,
    protocol272 = false,
}
--同步数据表里的协议是否都已经完成
function InitDataProtocalManager.IsFinishAllSyncPro()
    for key,syncProValue in pairs(InitDataProtocalManager.SyncProtocolList) do
        if(syncProValue == false) then
            if(Lua_GzLog.LOG_PROTOCOL) then
                logError("协议："..key.."还未完成");
            end
            return false;
        end
    end
    return true;
end

--同步数据是否完成
function InitDataProtocalManager.IsSyncFinished()
    return UserDataManager.Instance:IsSyncFinished();
end
--设置同步数据完成
function InitDataProtocalManager.SetSyncFinished()
    return UserDataManager.Instance:SetSyncFinished();
end
--刚进游戏初始化数据协议成功收到回调数据 会调这个方法，参数为协议号 目前刚进游戏同步数据的协议有 272-lua发   40-c#发 这两个协议如果都成功收到回调数据，并且数据有效，就停下主界面的转圈 同步完成
function InitDataProtocalManager.GetSyncCallBackSuccess(protocolNum)
    if(Lua_GzLog.LOG_PROTOCOL) then
        logError("协议："..protocolNum.."完成");
    end
    --设置对应同步数据协议为完成
    InitDataProtocalManager.SyncProtocolList["protocol"..protocolNum] = true;
    --如果所有同步协议都已完成
    if(InitDataProtocalManager.IsFinishAllSyncPro()) then
        if(Lua_GzLog.LOG_PROTOCOL) then
            logError("同步数据全部完成！！！！！！！！！！！！！");
        end
        --设置当前状态为同步完成状态
        InitDataProtocalManager.SetSyncFinished();--------------------同步完成
        --刷新主界面赛季奖励 领取奖励的宝箱提示
        ViewLoginPanel.RefreshQualifyRewardBtnEffect()
    end 
end
