--转盘界面
RotaryPanel = {}

--转盘旋转部分
RotaryPanel.goRotary  = nil
--抽奖按钮
RotaryPanel.btnRotary = nil
--领取奖励按钮
RotaryPanel.btnReward = nil
--关闭按钮
RotaryPanel.btnClose = nil
--转盘的可用次数
RotaryPanel.maxRotaryTimes = nil
--转盘剩余次数
RotaryPanel.remainRotaryTimes = nil
--奖励物品的index
RotaryPanel.ItemIndex = nil 
--抽奖label
RotaryPanel.rotaryLabel = nil
--二次提示界面
RotaryPanel.rotaryTip = nil
--二次提示文本
RotaryPanel.rotaryTipLabel  = nil
--领奖文本
RotaryPanel.rewardLabel = nil
--二次提示确定按钮
RotaryPanel.tipOkBtn = nil
--二次提示取消按钮
RotaryPanel.tipCancleBtn = nil
--确定按钮文本
RotaryPanel.tipOkLabel = nil
--取消按钮文本
RotaryPanel.tipCancleLabel = nil
--现在是否有奖励未领取
RotaryPanel.rewardRemain = false
--粒子效果
RotaryPanel.effcetGo = nil 
--每日刷新提示
RotaryPanel.tipLabel = nil
--转盘buff
RotaryPanel.buffs = nil
--转盘物品的详细描述面板
RotaryPanel.buffInfo = nil
--获得buff时的提示面板
RotaryPanel.buffTip = nil

function RotaryPanel.Awake(go)
    RotaryPanel.gameObject = go;
    RotaryPanel:InitComponent()
    RotaryPanel.gameObject:AddComponent(typeof(RotaryCtrl))
    RotaryPanel:RefreshUI()
end

function RotaryPanel.Start()

end
--刷新UI
function RotaryPanel:RefreshUI()
    RotaryPanel:GetRotaryItem()
end



--初始化界面组件
function RotaryPanel:InitComponent()
    logError("RotaryPanel:InitComponent==========================================");
    RotaryPanel.remainRotaryTimes =tonumber(UnityEngine.PlayerPrefs.GetString("RotaryTimes","0"))
    RotaryPanel.maxRotaryTimes =tonumber(UnityEngine.PlayerPrefs.GetString("MaxRotaryTimes","0"))
    
    RotaryPanel.rotaryTip = self.gameObject.transform:Find("Tip").gameObject
    RotaryPanel.rotaryTip:SetActive(false)

    RotaryPanel.effcetGo = self.gameObject.transform:Find("RotaryContainer/Bg/zhuanpan_effect").gameObject

    RotaryPanel.goRotary = self.gameObject.transform:Find("RotaryContainer/RotateGo").gameObject

    RotaryPanel.btnRotary = self.gameObject.transform:Find("RotaryContainer/Btn_Rotary").gameObject
    UIEventListener.Get(RotaryPanel.btnRotary).onClick = function() RotaryPanel:RotateLogic() end

    RotaryPanel.rotaryLabel = self.gameObject.transform:Find("RotaryContainer/Btn_Rotary/Label"):GetComponent('UILabel')
    if RotaryPanel.remainRotaryTimes~= nil and RotaryPanel.maxRotaryTimes ~= nil then
        RotaryPanel.rotaryLabel.text = LanguageManager.Instance:getLanguageByTID("start_rotary").."("..RotaryPanel.remainRotaryTimes.."/"..RotaryPanel.maxRotaryTimes..")"
    end

    RotaryPanel.btnClose = self.gameObject.transform:Find("RotaryContainer/Btn_Close").gameObject
    UIEventListener.Get(RotaryPanel.btnClose).onClick = function() RotaryPanel:ShowTips() end

    RotaryPanel.tipOkBtn = self.gameObject.transform:Find("Tip/again").gameObject
    UIEventListener.Get(RotaryPanel.tipOkBtn).onClick = function() RotaryPanel:ClosePanelLogic() end
    
    RotaryPanel.tipCancleBtn = self.gameObject.transform:Find("Tip/return").gameObject
    UIEventListener.Get(RotaryPanel.tipCancleBtn).onClick = function() RotaryPanel:TipCanCleClicked() end

    RotaryPanel.tipOkLabel = self.gameObject.transform:Find("Tip/again/Label_Confirm"):GetComponent('UILabel')
    RotaryPanel.tipOkLabel.text = LanguageManager.Instance:getLanguageByTID("button_confirm")
    
    RotaryPanel.tipCancleLabel = self.gameObject.transform:Find("Tip/return/Label_Cancel"):GetComponent('UILabel')
    RotaryPanel.tipCancleLabel.text = LanguageManager.Instance:getLanguageByTID("button_cancel")

    RotaryPanel.btnReward = self.gameObject.transform:Find("RotaryContainer/Btn_Reward").gameObject
    UIEventListener.Get(RotaryPanel.btnReward).onClick = function() RotaryPanel.CheckPlayAd() end

    RotaryPanel.rewardLabel = self.gameObject.transform:Find("RotaryContainer/Btn_Reward/Label"):GetComponent('UILabel')
    RotaryPanel.rewardLabel.text = LanguageManager.Instance:getLanguageByTID("video_reward_label")
    
    RotaryPanel.rotaryTipLabel = self.gameObject.transform:Find("Tip/Label"):GetComponent('UILabel')
    RotaryPanel.rotaryTipLabel.text = LanguageManager.Instance:getLanguageByTID("tip_rotary_reward")

    RotaryPanel.btnReward:SetActive(false)
    RotaryPanel.rewardRemain = false
    RotaryPanel.btnRotary:SetActive(true)

    RotaryPanel.tipLabel = self.gameObject.transform:Find("Label"):GetComponent('UILabel')
    RotaryPanel.tipLabel.text = LanguageManager.Instance:getLanguageByTID("rotary_refresh_everyday")

    RotaryPanel.buffInfo = self.gameObject.transform:Find("RotaryContainer/ItemInfo").gameObject
    RotaryPanel.buffInfo:SetActive(false)

    RotaryPanel.buffTip = self.gameObject.transform:Find("buffTip").gameObject
    RotaryPanel.buffTip:SetActive(false)
    RotaryPanel.infoCloseBtn = self.gameObject.transform:Find("buffTip/again").gameObject
    UIEventListener.Get(RotaryPanel.infoCloseBtn).onClick = function() RotaryPanel:CloseBuffTip() end
end

--关闭获得buff时的提示
function RotaryPanel:CloseBuffTip()
    RotaryPanel.buffTip:SetActive(false)
end
--二次提示界面取消按钮
function RotaryPanel:TipCanCleClicked()
        RotaryPanel.rotaryTip:SetActive(false)
end
--弹出二次提示界面
function RotaryPanel:ShowTips()
    if RotaryPanel.rewardRemain == true then
        RotaryPanel.rotaryTip:SetActive(true)
    else    
        RotaryPanel:ClosePanelLogic()
    end
end

--关闭当前panel
function RotaryPanel:ClosePanelLogic()
    UIManager.PopUI()
end

--转盘旋转逻辑
function RotaryPanel:RotateLogic()
    GzTK.TKEvent(TalkingDataConst.TKE_ROTARY_CLICKED);
    if RotaryPanel.effcetGo ~= nil then
        RotaryPanel.effcetGo:SetActive(false)
    end
    if RotaryPanel.remainRotaryTimes > 0 then
        local canAd = RotaryPanel:CheckAdStateNotEvent()
        if canAd == RotaryConst.AD_CHANEL_CAN_NOT then
            TipsManager.Instance:showTipOnce(LanguageManager.Instance:getLanguageByTID("ads_is_not_ready"), Vector3.New(0, UnityEngine.Screen.height / 10 * 2, 0))
            logError("RequestUserReward--广告渠道无广告,不能转盘===================================")
        else
            RotaryCtrl.Instance:PlayTweener()
            RotaryPanel.rewardRemain = true
            RotaryPanel.btnRotary:SetActive(false)
        end
    else
        TipsManager.Instance:showTipOnce(LanguageManager.Instance:getLanguageByTID("no_ratary_time"), Vector3.New(0, UnityEngine.Screen.height / 10 * 2, 0))
    end
end
--检测广告状态,不算广告点击
function RotaryPanel:CheckAdStateNotEvent()
    return RotaryPanel:CheckAdState(false);
end
--检测广告状态,算一次广告点击事件
function RotaryPanel:CheckAdStateAndEvent()
    return RotaryPanel:CheckAdState(true);
end
--检测广告状态,
function RotaryPanel:CheckAdState(runEvent)

    local panelName = RotaryPanel.gameObject.name
    local hasAd = UserDataManager.IsChannelHasAd();
    if hasAd  then
        if (AvoidAdActivity.Instance:CanAvoidAd()) then        --免广告 不算点击播放广告事件
            logError("CheckAdState--广告渠道免广告================================")
            --AdsManager.Instance:showLoginVideoComplete(true);
            return RotaryConst.AD_CHANEL_AVOID
        else
            if runEvent then
                GzAdEventSta.Instance():setClickAdVideo(panelName);    
            end
            local rd = AdsManager.Instance:loginVideoIsCanShowOfRD()
            if(rd:isSuccess()) then--如果激励视频可播放 
                logError("CheckAdState--广告渠道有广告==================================== ")               
                return RotaryConst.AD_CHANEL_CAN
            else
                logError("CheckAdState--广告渠道无广告==================================== ")
                if runEvent then
                    if(GzAdEventSta.Instance():setIsFail (panelName)) then
                        GzTK.TKEventOfADError( rd:getAdErrorCode(),panelName);
                    end   
                end
                return RotaryConst.AD_CHANEL_CAN_NOT            
            end     
        end
    else 
        logError("CheckAdState--非广告渠道================================")
        return RotaryConst.NOT_AD_CHANEL
    end
    return RotaryConst.AD_CHANEL_CAN_NOT   
end
--发送协议311,从服务器获取玩家本次的转盘奖励
function RotaryPanel.RequestUserReward()
    --if(Lua_GzLog.LOG_PROTOCOL) then
        logError("发送311  lua！！！！！！！！！！！！！！！！！！！！！！！！！！！！")
    --end
    local taskType = NetConfig.HttpTaskType.HttpTaskType_Rotary_Reward_Confirm;
    local param = JsonObject.New();
    param:encode("","");
    local luaClass = "RotaryPanel"
    local luaFun = "GetUserReward"
    GzNet.Call(taskType,param,luaClass,luaFun)
end
--311回调
function RotaryPanel.GetUserReward(netData)
    if netData then
        if netData._data then
            logError("GetUserReward--数据============================="..netData._data);
            local rData =  tools_Cjson.decode(netData._data)
            if rData.code == 0 then
                local indexId = rData.data.indexId
                local usedNum = rData.data.usedNum
                local remainingNum = rData.data.remainingNum
                RotaryPanel.remainRotaryTimes = remainingNum
                UnityEngine.PlayerPrefs.SetString("RotaryTimes",tostring(remainingNum))
                RotaryPanel.ItemIndex = indexId
                RotaryPanel:SlowDownLogic()
            end 
        end
    end
end
--转盘减速,停到给定的奖励
function RotaryPanel:SlowDownLogic()
    logError("SlowDownLogic()-------------------------------"..RotaryPanel.ItemIndex)
    RotaryCtrl.Instance:SlowDownLogic(RotaryPanel.ItemIndex)
    RotaryPanel.rewardRemain = true
    RotaryPanel.btnRotary:SetActive(false)
end
--检测广告 广告渠道先播广告后领取物品  非广告渠道直接领取
function RotaryPanel.CheckPlayAd()
    GzTK.TKEventOfValue(TalkingDataConst.TKE_ROTARY_AD_USER_HERO_NUM,tostring(HeroSkinManager.Instance:HeroHasNum()))
    local canAd = RotaryPanel:CheckAdStateAndEvent()
    if canAd == RotaryConst.AD_CHANEL_CAN then
        GzTK.TKEvent(TalkingDataConst.TKE_ROTARY_VEDIO)
        logError("CheckPlayAd--开始播放广告========================================")
        AdsManager.Instance:showLoginVideo(GzAdParam.GetParamOfRotary(),true);
    elseif canAd == RotaryConst.AD_CHANEL_CAN_NOT then
        logError("CheckPlayAd--广告渠道无广告,不领取奖励========================================")
        TipsManager.Instance:showTipOnce(LanguageManager.Instance:getLanguageByTID("ads_is_not_ready"), Vector3.New(0, UnityEngine.Screen.height / 10 * 2, 0))
    elseif canAd == RotaryConst.AD_CHANEL_AVOID then
        logError("CheckPlayAd--广告渠道免广告,领取奖励========================================")
        RotaryPanel.GetReward()
    elseif canAd == RotaryConst.NOT_AD_CHANEL then
        logError("CheckPlayAd--非广告渠道,领取奖励========================================")
        RotaryPanel.GetReward()
    end
end

--领取奖励物品
function RotaryPanel.GetReward()
    RotaryPanel:SendRewardProtocal()
    RotaryPanel.btnReward:SetActive(false);
end
--获取当日转盘物品信息
function RotaryPanel:GetRotaryItem()
    local allItem = UnityEngine.PlayerPrefs.GetString("RotaryItem")
    if allItem ~= nil then
        logError(""..allItem)
        local rotaryList = string.split(allItem,",")
        for k,v in pairs(rotaryList) do
            local array  = {0,0,0}
            local info = string.split(v,":") 
            local indexId = info[1]
            local itemId = info[2]
            local itemNum = info[3]
            RotaryPanel:SetRotaryItem(indexId,itemId,itemNum)
        end
    end
end
--设置转盘物品显示
function RotaryPanel:SetRotaryItem(indexId,itemId,itemNum)
    -- logError("indexId:"..indexId.."===========itemId:"..itemId.."=============itemNum:"..itemNum)
    local curItem = self.gameObject.transform:Find("RotaryContainer/RotateGo/Item"..indexId).gameObject
    local itemLabel = self.gameObject.transform:Find("RotaryContainer/RotateGo/Item"..indexId.."/Label"):GetComponent('UILabel')
    local itemSprite = self.gameObject.transform:Find("RotaryContainer/RotateGo/Item"..indexId.."/Reward"):GetComponent('UISprite')
    itemLabel.text = "x"..itemNum
    itemSprite:SetDimensions(60,60)
    itemLabel.gameObject:SetActive(true)
    if itemId == '800'then
            itemSprite:SetDimensions(64,64)
            itemLabel.gameObject:SetActive(false)
        elseif itemId == '801'then
            itemSprite:SetDimensions(64,64)
            itemLabel.gameObject:SetActive(false)
        elseif itemId == '802'then
            itemSprite:SetDimensions(64,64)
            itemLabel.gameObject:SetActive(false)
        elseif itemId == '803'then
            itemSprite:SetDimensions(64,64)
            itemLabel.gameObject:SetActive(false)
        end
    
    local itemState = UnityEngine.PlayerPrefs.GetInt("RotaryItem"..indexId)
    if itemState == 0 then
        --logError("物品未获得========="..indexId.."=="..itemId)
    elseif itemState == 1 then
        --获得buff时,buff显示已领取
        if itemId == '800'then
            itemSprite:SetDimensions(64,64)
            itemLabel.gameObject:SetActive(true)
        elseif itemId == '801'then
            itemSprite:SetDimensions(64,64)
            itemLabel.gameObject:SetActive(true)
        elseif itemId == '802'then
            itemSprite:SetDimensions(64,64)
            itemLabel.gameObject:SetActive(true)
        elseif itemId == '803'then
            itemSprite:SetDimensions(64,64)
            itemLabel.gameObject:SetActive(true)
        end
        itemLabel.text = LanguageManager.Instance:getLanguageByTID("card_reward_collected")
    else
        logError("RotaryPanel:SetRotaryItem--非法的物品领取状态======") 
    end
    

    
    if itemId == '501' then 
        itemSprite.spriteName = '501'
    elseif itemId == '502' then
        itemSprite.spriteName = '502'
    else
        local rotaryItem = nil
        local propId = tonumber(itemId);
        rotaryItem = PropDicDataManager.Instance:getPropDicItemOfKey(propId);
        itemSprite.spriteName = rotaryItem.propSprite
    end

    
    -- logError("刷新界面显示=============================================================================")
    -- logError(tostring(RotaryPanel.remainRotaryTimes))
    -- logError(RotaryPanel.remainRotaryTimes>0)
    if ViewLoginPanel.rotaryRedDot~= nil then
        ViewLoginPanel.rotaryRedDot:SetActive(RotaryPanel.remainRotaryTimes>0)
    end
end

--重置转盘灯
function RotaryPanel:ResetLight()
    RotaryCtrl.Instance:LightReset()
end

--领取奖励协议312
function RotaryPanel:SendRewardProtocal()
    --if(Lua_GzLog.LOG_PROTOCOL) then
        logError("发送312  lua！！！！！！！！！！！！！！！！！！！！！！！！！！！！")
    --end
        local taskType = NetConfig.HttpTaskType.HttpTaskType_Rotary_Reward_Get;
        local param = JsonObject.New();
        param:encode("","");
        local luaClass = "RotaryPanel"
        local luaFun = "GetRewardProtocal"
        GzNet.Call(taskType,param,luaClass,luaFun) 
        UIManager.showLoading(true)
end

--领取奖励协议312返回
function RotaryPanel.GetRewardProtocal(netData)
    UIManager.showLoading(false)
    if netData then
        if netData._data then
            --logError("GetRewardProtocal--数据============================="..netData._data);
            local rData =  tools_Cjson.decode(netData._data)
            if rData.code == 0 then
                local changeValue = rData.data.changeValue
                local rewardValue = rData.data.rewardValue
                local finalValue = rData.data.finalValue
                --当前生效的buffId，多个用英文逗号隔开
                local buffs = rData.data.buffs 
                logError("buffs==nil#+#+#+#+#+#+#+#+#++#+#+#+#+#+#+##+#+#+#+#+#+##+#+#+#+##+#+#+")
                logError(buffs == nil)
                if buffs ~= nil then
                    logError("当前生效的buffid+#+#++#+#+#+#+#+#  :"..buffs)
                end
                local type = PropDicDataManager.Instance:getPropDicItemOfKey(RotaryItemData:GetItemByIndex(RotaryPanel.ItemIndex).id).propType
                if type == 11 then
                    --得到的是buff,没有道具变动
                    GzTK.TKEvent(TalkingDataConst.TKE_GET_BUFF)
                    RotaryPanel.buffs = buffs
                    RotaryCtrl.Instance.SaveActBuffs(buffs)
                else
                    PropVarDataManger.Instance:HandleReceiveReward(changeValue,finalValue)
                end
                
                UnityEngine.PlayerPrefs.SetInt("RotaryItem"..tostring(RotaryPanel.ItemIndex),1)
                if  type == 1 then 
                    RotaryCtrl.Instance:PlayDiamondAnim()
                elseif type == 11 then
                    RotaryPanel:ShowBuffGotTip()
                else 
                    RotaryCtrl.Instance:ShowHeroOrEggEffect()
                end 
                -- print("PropVarDataManger--GetPropVarDataItemOfPropId--type======"..type)
            end
        end
    end     
    RotaryPanel.btnReward:SetActive(false)
    RotaryPanel.btnRotary:SetActive(true)
    RotaryPanel.rewardRemain = false
    RotaryPanel.rotaryLabel.text = LanguageManager.Instance:getLanguageByTID("start_rotary").."("..RotaryPanel.remainRotaryTimes.."/"..RotaryPanel.maxRotaryTimes..")"
    RotaryPanel:RefreshUI()
    RotaryPanel:ResetLight()
end
--得到buff时会弹出buff信息提示框
function RotaryPanel:ShowBuffGotTip()
    RotaryPanel.buffTip:SetActive(true)
    self.gameObject.transform:Find("buffTip/l/Label"):GetComponent('UILabel').text = RotaryPanel.GetInfoByIndex(RotaryPanel.ItemIndex)
    self.gameObject.transform:Find("RotaryContainer/ItemInfo").gameObject:SetActive(false)
    local sp = self.gameObject.transform:Find("buffTip/buffIcon"):GetComponent('UISprite')
    RotaryPanel.GetSpriteNameByIndex(RotaryPanel.ItemIndex,sp)
end

--根据参数 显示 当前的粒子特效
function RotaryPanel.ShowCurEffect(isShow)
    if RotaryPanel.effcetGo ~= nil then
        RotaryPanel.effcetGo:SetActive(isShow)
    end
end 
-- 返回当前得到的物品的  id 和 数量  用于 给unity 得到
function  RotaryPanel.getCurPropData()
    local  item  = RotaryItemData:GetItemByIndex(RotaryPanel.ItemIndex)
    if  item~= nil then 
            return item.id ,item.num 
    end 
    return  nil ,nil 
end 

--根据index获得物品的spriteName
function RotaryPanel.GetSpriteNameByIndex(ItemIndex,_UISprite)
    local item = RotaryItemData:GetItemByIndex(ItemIndex)
    local spriteName = nil
    if item.id == '501' then 
        spriteName = '501'
    elseif item.id == '502' then
        spriteName = '502'
    else
        local rotaryItem = nil
        local propId = tonumber(item.id);
        rotaryItem = PropDicDataManager.Instance:getPropDicItemOfKey(propId);
        spriteName = rotaryItem.propSprite
    end
    _UISprite.spriteName = spriteName
end

--根据物品的index获得物品的详细描述
function RotaryPanel.GetInfoByIndex(ItemIndex)
    local item  = RotaryItemData:GetItemByIndex(ItemIndex)
    local type = PropDicDataManager.Instance:getPropDicItemOfKey(RotaryItemData:GetItemByIndex(ItemIndex).id).propType
    local showInfo = false
    local info = ""
    if type == 11 then
        if item.id == '800'then
            info = LanguageManager.Instance:getLanguageByTID("hero_buff_twice")
        elseif item.id == '801'then
            info = LanguageManager.Instance:getLanguageByTID("hero_buff_third")
        elseif item.id == '802'then
            info = LanguageManager.Instance:getLanguageByTID("pet_buff_twice")
        elseif item.id == '803'then
            info = LanguageManager.Instance:getLanguageByTID("pet_buff_third")
        end
        showInfo = true
    end
    return info,showInfo
end

