﻿HeadBorderUiItem = {};

function HeadBorderUiItem.New()
    local item = {};
    setmetatable(item,HeadBorderUiItem);
    HeadBorderUiItem.__index = HeadBorderUiItem;
    item.borderData = nil;
    item.go = nil;
    return item;
end

--当前头像是否未解锁
function HeadBorderUiItem:IsUnlocked()
    return self.borderData:IsUnlocked();
end
--赋数据
function HeadBorderUiItem:SetData(data,obj)
    self.borderData = data;
    self.go = obj;
    --初始化逻辑
    self:InitLogic();
end

function HeadBorderUiItem:InitLogic()
    self:InitUi();
end

--初始化ui
function HeadBorderUiItem:InitUi()
    HeadBorderDataManager.SetSpriteByBorderId(self.go:GetComponent("UISprite"),self.borderData.headId);    
    local isNew = self.borderData:IsNewBorder();
    self.go.transform:Find("redot").gameObject:SetActive(isNew);
    if(isNew) then
        self.borderData:SetNew(false);--置为不是新获得的
    end
    local closeFunc = function()   self:ClickBorderLogic(); end;
    UIEventListener.Get(self.go).onClick = closeFunc;
end

--点击头像框
function HeadBorderUiItem:ClickBorderLogic()        
        SelectHeadBorderPanel:RefreshBorderDescPanel(self.borderData,self.go.transform.localPosition);           
end