﻿--任务的常亮数据管理
QuestTaskDicSystem = {}
--所有的数据
QuestTaskDicSystem.allTasksLst = {}

--获得所有任务
function   QuestTaskDicSystem:GetAllDicTasks()
        return self.allTasksLst
end 
--放入数据
function   QuestTaskDicSystem:PutDataItem(item)
        table.insert( self.allTasksLst,item)
end 
--根据任务的id 获得 具体的任务
function QuestTaskDicSystem:GetTasksOfTaskId(questId)
    for k,v in pairs(self.allTasksLst) do
       if v.questId== questId  then
           return v
       end
    end
    return nil
end  
--初始化数据
function  QuestTaskDicSystem:InitData()
      local jsonTable = JsonManage:GetTableItemOfName(JsonConstant.TB_Z_QUEST_LIBRART)
      local jsonList = jsonTable:GetJsonTable()
      local questTaskDicItem = nil
      for key, var in pairs(jsonList) do 
        questTaskDicItem = QuestTaskDicItem.New()
        questTaskDicItem.questId = var.questId 
        local taskItem  = self:GetTasksOfTaskId(questTaskDicItem.questId)
        if taskItem == nil  then
            questTaskDicItem.type = var.type 
            questTaskDicItem.require = var.require
            --questTaskDicItem.dec = var.dec
            questTaskDicItem.dec = "task_type_"..var.type
            questTaskDicItem.value = var.value
            questTaskDicItem.star = var.star
            self:PutDataItem(questTaskDicItem);
        end 
      end
           
end 