-- json常量表
JsonConstant =
{

    TB_Z_CLIENT_JSON_SYSTEM="tb_z_client_json_system",   --客户端系统表

    TB_Z_QUEST_LIBRART = "quest_library",-- 任务常量表
    --TB_Z_VIP_INFO = "tb_z_vip_info",--会员信息表
    TB_Z_QUALIFY_REWARD_CONFIG="quest_reward_config",--赛季奖励表1
    TB_Z_QUALIFY_REWARD_GROUP="quest_reward_group",--赛季奖励表2
    TB_Z_Head_BORDER = "head_frame_config",      --头像框数据表
    TB_LANGUAGE_LUA = "language_lua",--多语言表
    PET_CONFIG = "pet_config",--小跟班的配置表
    PET_PIECE_CONFIG = "pet_piece_config",--小跟班的 碎片表

    TB_PET_CONFIG="pet_config",         --小跟班
    TB_PET_PIECE_CONFIG="pet_piece_config",--小跟班碎片
}

JsonConstant.__index = JsonConstant



--初始化jsonKey表 以classItem为生成的对像 返回一个list
function JsonConstant.GetItemListOfInitJson(jsonKey,classItem)
    local jsonTable = JsonManage:GetTableItemOfName(jsonKey) 

    local jsonKey = jsonTable:GetJsonKey()
    --print("HeroSkillDictsys:InitData start[[[[[[[[[[[[[[[[[[")
    
    local jsonList = jsonTable:GetJsonTable()

    local list = {}

    for key, var in pairs(jsonList) do        
        local jsonItem = classItem.New()
         
        
        for fieldName,value in pairs(var) do
            jsonItem[fieldName] = value
        end


         
        --print(jsonItem:GetMessage()) 

        table.insert(list,jsonItem)
    end

    return list
end

--初始化jsonKey表 以classItem为生成的对像 并执行fun方法 来将数据放到system中 具体怎么放 由fun来定
-- fun的写法 如 FunctionDictionaryManage:AddFunctionItem（item)
function JsonConstant.InitJsonDataToSystem(jsonKey,classItem,fun)
    local jsonTable = JsonManage:GetTableItemOfName(jsonKey)

    local jsonKey = jsonTable:GetJsonKey()
    --print("HeroSkillDictsys:InitData start[[[[[[[[[[[[[[[[[[")
    
    local jsonList = jsonTable:GetJsonTable()

  

    for key, var in pairs(jsonList) do        
        local jsonItem = classItem.New()
         
        
        for fieldName,value in pairs(var) do
            jsonItem[fieldName] = value

            
        end


         
        --print(jsonItem:GetMessage()) 

        fun(jsonItem)
    end

    --移除原始数据
    JsonManage:RemoveTableOfName(jsonKey)
end

--return JsonConstant

--endregion


