--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

JsonManage = 
{
	list = {}
}
-- JsonManage.__index = JsonManage
--newTable json表  key：表中以哪个字面为key值，name:表名
function JsonManage:PutData (newTable, key, name)
    newJsonItem = JsonItem:New()
    newJsonItem.jsonTable = newTable
    if key ~= nil then
        newJsonItem.jsonKey = key
    else
        newJsonItem.jsonKey = "json number" .. table.maxn (JsonManage.list)
    end
    if name ~= nil then
        newJsonItem.jsonName = name
    else
        newJsonItem.jsonName = "error table" .. table.maxn (JsonManage.list)
    end
    table.insert (self.list, newJsonItem)
    newJsonItem = nil
end

--获得参数表的数据  如果是生成类对像 可以调用 RemoveTableOfName 来移除原始数据
function JsonManage:GetTableItemOfName (jsonName)
    item = {}
    for key, var in pairs (self.list) do
        if var:GetJsonName () == jsonName then
            item = var
            return item
        end
    end
    logError("未找到json表 检查tb_z_json_system")
    logError(jsonName)
    logError("未找到json表"..jsonName)
    return item
end

--移除一个jsonTable 用于 常量数据用完后 
function JsonManage:RemoveTableOfName(jsonName)
     for key, var in pairs (self.list) do
        if var:GetJsonName () == jsonName then
            -- logError("移除表"..jsonName.."key为"..key)
            self.list[key]=nil
            break
        end
    end
end

--endregion

function JsonManage:Print()
    print("JsonManage:Print")
    print(#self.list)
    for k,v in pairs(self.list) do

        print(k,v.jsonKey)
    end
end


--return JsonManage