JsonBuffer={}

function JsonBuffer.New()
    local item = {}

    setmetatable(item,JsonBuffer)
    JsonBuffer.__index = JsonBuffer

    item.text=""
    item.content=""

    item.contentList={}


    --临时项
    item.tempContent=""
    return item
    
end


--添加一项 项是字符串
function JsonBuffer:AddItem(str)

    if(self.tempContent == nil) then
    
        self.tempContent =str
    else
        self.tempContent = self.tempContent ..",\r\n"
        self.tempContent = self.tempContent ..str
    end
end

function JsonBuffer:AddString(key,value)
    local str  ="\""..key.."\":\""..value.."\""
    self:AddItem(str)
end

--添加一项 项是字符串
function JsonBuffer:AddInt(key,value)

    local str = "\""..key.."\":"..value
    self:AddItem(str)
    
end

--创建一组
function JsonBuffer:CreateGroup()
    self.tempContent = nil
    

end

--结束一组
function JsonBuffer:EndGroup()

    
    self.tempContent = "{\r\n" ..self.tempContent.."\r\n}"

    

    table.insert(self.contentList,self.tempContent);
    self.tempContent = ""
end


--获得json最终内容
function JsonBuffer:GetJsonContent()
    local text = ""

    for i,v in ipairs(self.contentList) do
        text = text..v
        if(i<#self.contentList) then
            text =text..","
        end
        text= text.."\r\n"
    end

    return text
end


function JsonBuffer:GetAllJsonText()
    return self:GetJsonStruct(self:GetJsonContent())
end
--获得json结构
function JsonBuffer:GetJsonStruct(text)
    local sb = nil
    sb= "{\r\n";
    sb = sb..("\"RECORDS\":[\r\n");

    sb = sb..text;

    sb = sb.."]\r\n";
    sb = sb.."}"

    return sb
end


