
LuaPrintTools = {}

--输出一个table 
function LuaPrintTools:PrintTable(theTable)
	print("print the table")
	if( type(theTable)~= "table") then
		print("not a table")
	end
    print(theTable)
    local subTable={}
    local subTableCount=0
	for k,v in pairs(theTable) do
        print(k,v)
        if(type(v)=="table") then
            subTable[k]=v
            subTableCount=subTableCount+1
        end

    end
    
    print("子表共有"..subTableCount)
    for k,v in pairs(subTable) do
        print("输出"..k.."表")
        LuaPrintTools:PrintTable(v)
    end
end


--返回是不是一个纯数字的table
function LuaPrintTools:IsArrayTable(t)  
    if type(t) ~= "table" then  
        return false  
    end  
  
    local n = #t  
    for i,v in pairs(t) do  
        if type(i) ~= "number" then  
            return false  
        end  
          
        if i > n then  
            return false  
        end   
    end  
  
    return true   
end  




function ToStringEx(value)
    if type(value)=='table' then
       return TableToStr(value)
    elseif type(value)=='string' then
        return "\'"..value.."\'"
    else
       return tostring(value)
    end
end


function TableToStr(t)
    if t == nil then return "" end
    local retstr= "{"

    local i = 1
    for key,value in pairs(t) do
        local signal = ","
        if i==1 then
          signal = ""
        end

        if key == i then
            retstr = retstr..signal..ToStringEx(value)
        else
            if type(key)=='number' or type(key) == 'string' then
                retstr = retstr..signal..'['..ToStringEx(key).."]="..ToStringEx(value)
            else
                if type(key)=='userdata' then
                    retstr = retstr..signal.."*s"..TableToStr(getmetatable(key)).."*e".."="..ToStringEx(value)
                else
                    retstr = retstr..signal..key.."="..ToStringEx(value)
                end
            end
        end

        i = i+1
    end

     retstr = retstr.."}"
     return retstr
end


function StrToTable(str)
    if str == nil or type(str) ~= "string" then
        return
    end
    
    return loadstring("return " .. str)()
end

--return LuaPrintTools

function netDataStrToTable(str)
    local testStr = str

    
    testStr = UnityLuaTools.Replace(testStr,"[","");
    testStr = UnityLuaTools.Replace(testStr,"]","");

    testStr = (string.gsub(testStr,"{\"","{[\'"))
    
    logError(testStr);
    --testStr = (string.gsub(testStr,"}",""))
    
    logError(testStr);
    testStr = (string.gsub(testStr,"\":","\']="))
    
    
    logError(testStr);
    testStr = (string.gsub(testStr,",\"",",[\'"))
    --testStr = (string.gsub(testStr,"[\':","\']="))
    
    
    logError("new string")
    logError(testStr);
    
    --local jsonTable = StrToTable(testStr)
    --LuaPrintTools:PrintTable(jsonTable)
    return testStr
end