MathTools={}

--取整
function MathTools.GetIntPart(x)
    if(x<=0) then
        return math.ceil(x)
    end
    local value = math.ceil(x)
    if(value==x) then
        return value
    else

        return value-1
    end
end

-- 保留小数点自定义位数 n不填就是只要整数  四舍五入
function MathTools.GetPreciseDecimal(num, n)
	if type(num) ~= "number" then
        return num;
    end

    n = n or 0;
    n = math.floor(n)
    local fmt = '%.' .. n .. 'f'
    --print("num = ".. num)
    --print("sub format"..string.format(fmt, num))

    

    
    local nRet = tonumber(string.format(fmt, num))
    return nRet;
end
-- 取小数点  非四舍五入
function MathTools.GetPreciseDecimalActual(nNum,n) 
    if type(nNum) ~= "number" then
         return nNum
    end
    if(nNum ==0) then
        return 0
    end
    n = n or 0;
    n = math.floor(n)
    if n < 0 then
        n = 0;
    end
    local nDecimal = 1/(10 ^ n)
    if nDecimal == 1 then
        nDecimal = nNum;
    end
    local nLeft = nNum % nDecimal;
    return nNum - nLeft;
end 

function MathTools.tonumber(value)
    return tonumber(value)
end

function MathTools.IsNumber(key)
    return LuaTools.IsNumber(key)
end