--BehaviourTools
UnityTools = {}


UnityTools.ComponentName_Sprite="UISprite"
UnityTools.ComponentName_Lbl="UILabel"
--横联花纹透明度
UnityTools.flowerAplhaVale = 120/255
UnityTools.PRINT_FLAG = false and true

UnityTools.farPosition = Vector3.New(10000,0,0)

--设置是否显示
function UnityTools.SetActive(object,yn)
	--暂时先不大改
	--UnityTools.SetActivityLogic(object,yn);

	
	if(object.gameObject ~=nil) then
		object.gameObject:SetActive(yn)
	else
		logError("设置Active时出错 不是gameObject")
		object.gameObject:SetActive(yn)
	end
	
	
end



--设置图片名字
function UnityTools.SetSpriteName(object,name)
	object.gameObject:GetComponent("UISprite").spriteName = name

	--print("setSpriteName")
	--print(name)

	local btn = object.gameObject:GetComponent("UIButton")
	if(btn~=nil) then
		
		btn.normalSprite=name;
		btn.hoverSprite=name;
		btn.pressedSprite=name;
	end
end

function UnityTools.SetSpriteAndButtonName(object,name)
	object.gameObject:GetComponent("UISprite").spriteName = name

	--print("setSpriteName")
	--print(name)

	local btn = object.gameObject:GetComponent("UIButton")
	if(btn~=nil) then
		
		btn.normalSprite=name;
		btn.hoverSprite=name;
		btn.pressedSprite=name;
	end
end

-- 随机数  传入 两个 int 值 进行随机
function UnityTools.RandomNum(a,b)
	local num = math.random(a,b)
	return num 
end 


--设置按钮是否有效  sprite如果为空 在btn查找 如果找不到不管 
function UnityTools.SetButtonEnable(go,yn,sprite)
	
	
	local btn = go:GetComponent("UIButton")
	if(sprite == nil) then
		sprite = btn.gameObject:GetComponent("UISprite")
	end
	btn.gameObject:GetComponent("BoxCollider").enabled=yn

	--以下一定要区分顺序 不然在enabled变为真时 会重置颜色
	if(yn) then
		UnityTools.ResetSpriteOfGary(sprite)
		btn.enabled=yn;
	else
		btn.enabled=yn;
		UnityTools.SetSpriteOfGary(sprite)
	end
	
	
end
--如果大于一万 就返回 一万为单位
function UnityTools.GetNumByW(nums,numType)
	local numsss = -1
	local tnum =  MathTools.tonumber(nums)
	
	if  numType ==  1  or numType == 2 then 
		--print("numTypenumTypenumTypenumTypenumType"..numType)
		if tnum <1000000 then 
		numsss = tnum
		else
			local cNum = tnum/10000
			--print("cNum........."..cNum)
			numsss = MathTools.GetPreciseDecimalActual(cNum,1).."万"
		end 
	else
		if tnum <10000 then 
		numsss = tnum
	   else
		local cNum = tnum/10000
		--print("cNum........."..cNum)
		numsss = MathTools.GetPreciseDecimalActual(cNum,1).."万"
		end 
		if tnum >10000000 then 
			local cNum = tnum/10000
			numsss = math.floor(cNum).."万"
		end 
	end 
	--print("nums"..nums)
	
	
--	print(numsss.."--------------------tnum"..tnum)
	return tostring(numsss)
end 



--设置深度
function UnityTools.SetDepth(go,depthValue)
	local widget = go:GetComponent("UIWidget")
	widget.depth = depthValue
end

--增加深度
function UnityTools.AddDepth(go,depthValue)
	local widget = go:GetComponent("UIWidget")
	widget.depth = widget.depth + depthValue
end

--增加在参数基础上深度
function UnityTools.AddDepthOfTarget(go,target,depthValue)
	local widget = go.transform:Find("redDotPre/Sprite"):GetComponent("UIWidget")
	local targetWidget = target:GetComponent("UIWidget")
	widget.depth = targetWidget.depth + depthValue
end
	

--设置控件是否有效
function UnityTools.SetCompentEnabled(component,yn)
	component.enabled = yn
end

--设置图片置灰 yn参数为假时 表示取消置灰
function UnityTools.SetSpriteOfGary(sprite,yn)
	if(yn==false) then
		sprite.color = Color.New(1,1,1);
	else
		sprite.color = Color.New(50/255,1,1);
	end

end

--设置图片置灰 yn参数为假时 表示取消置灰
function UnityTools.SetGameObjectOfGary(go,yn)
	local sprite = go:GetComponent("UISprite")
	if(yn==false) then
		sprite.color = Color.New(1,1,1);
	else
		sprite.color = Color.New(50/255,1,1);
	end

end



--取消图片置灰
function UnityTools.ResetSpriteOfGary(sprite)
	sprite.color = Color.New(1,1,1);

end

--设置label置灰 yn参数为假时 表示取消置灰
function UnityTools.SetUILabelOfGary(go,yn)
	local sprite = go:GetComponent("UILabel")
	if(yn==false) then
		sprite.color = Color.New(1,1,1);
	else
		sprite.color = Color.New(188/255,188/255,188/255);
	end
end


--以vector3 x z 为参数，获得vector2的距离
function UnityTools.GetDistanceOfV3(startP,endP)
	local v2s = Vector2.New(startP.x,startP.z)
	local v2e = Vector2.New(endP.x,endP.z)
	return Vector2.Distance(v2s,v2e)
end

--以vector3 x,y为参数，获得vector2的距离
function UnityTools.GetDistanceOfV3XY(startP,endP)
	local v3s = Vector3.New(startP.x,startP.y,0)
	local v3e = Vector3.New(endP.x,endP.y,0)
	return Vector3.Distance(v3s,v3e)
end


--以v2的方式（不看y值)lookat一个v3的坐标
function UnityTools.LootAtOfV3(go,targetV3)
	--local v3 = Vector3.New(targetV3.x ,targetV3.y, targetV3.z)

	local v3 = Vector3.New(targetV3.x ,targetV3.y,go.transform.position)
	--logError("看向坐标"..targetV3.x..";"..targetV3.y..";"..go.transform.position.z)
	--logError("原坐标"..go.transform.position.x..";"..go.transform.position.y..";"..go.transform.position.z)
	go.transform:LookAt(v3)
end

--当物体站在 start 时 向end 看 得到的角度 而不是现在的位置
function UnityTools.LootAtOfStartEndPosition(go,startP,endP)
	local oldP = go.transform.position;

	go.transform.position = startP;

	
	--logError("看向坐标"..targetV3.x..";"..targetV3.y..";"..go.transform.position.z)
	--logError("原坐标"..go.transform.position.x..";"..go.transform.position.y..";"..go.transform.position.z)
	go.transform:LookAt(endP)
	go.transform.position = oldP
end


--以v2的方式（不看y值)lookat一个v3的坐标
function UnityTools.LootAtOfV3Of2D(go,srcCityPosition,targetV3)

	local tempP = Vector3.New(srcCityPosition.x,srcCityPosition.y,srcCityPosition.z)
	


	local angleValue = UnityTools.GetAngleOfPosition(tempP,targetV3)

	
	--logError("UnityTools.LootAtOfV3Of2D看向坐标"..targetV3.x..";"..targetV3.y..";"..go.transform.position.z)
	--logError("UnityTools.LootAtOfV3Of2D原坐标"..srcCityPosition.x..";"..srcCityPosition.y..";"..srcCityPosition.z)
	local q = Quaternion.New()
	--logError("得到角度"..angleValue)
	q.eulerAngles = Vector3.New(0,0,angleValue);
	go.transform.localRotation = q
end


--获得两点的x与y距离
function UnityTools.GetPositionDiff(startP,endP)

	local p = Vector3.New()
	--默认认为startX小于endX  startX在左 end 在右
	local diffX = nil
	if(endP.x>startP.x) then
		diffX = (endP.x-startP.x)
	else
		diffX = -(startP.x-endP.x)
	end
	
	
	local diffY = nil
	if(endP.y>startP.y) then
		diffY = (endP.y-startP.y)
	else
		diffY = -(startP.y-endP.y)
	end

	p.x = diffX 
	p.y = diffY 
	p.z = endP.z
	return p
end

function UnityTools.GetAngleOfPosition(startP,endP)
 
	local tempP = startP;
	local targetV3 = endP;


	
	tempP = UnityTools.GetPositionDiff(startP,endP)

	if(UnityTools.PRINT_FLAG) then
		logError("原点"..tempP.x..";"..tempP.y)

		logError("目标点"..targetV3.x..";"..targetV3.y)
		logError("差值"..tempP.x..";"..tempP.y)
	end

	local tempCountP = Vector3.New(tempP.x,tempP.y,tempP.z)
	if(tempCountP.x<0) then tempCountP.x = 1-tempCountP.x end
	if(tempCountP.y<0) then tempCountP.y = 1-tempCountP.y end
	if(tempCountP.z<0) then tempCountP.z = 1-tempCountP.z end

	
	local value = (Mathf.Atan2(tempCountP.x,tempCountP.y));
	
	local finalValue =value * Mathf.Rad2Deg;

	if(UnityTools.PRINT_FLAG) then
		logError("得到坐标"..tempCountP.x..";"..tempCountP.y)
		logError("得到弧度"..value)
		logError("得到角度"..finalValue)
		logError("进行转换")
	end


	
	if(tempP.x>0) then
		if(tempP.y>0) then
			finalValue = -finalValue
		else --   x>0 y<0
			finalValue= 180+finalValue
		end

	else
		if(tempP.y>0) then
			finalValue= finalValue
		else-- x<0 y<0
			finalValue= 90 + 90 -finalValue
		end
	end
	return finalValue;

	
end



function UnityTools.Abs(value)
	if(value<0) then
		return -value
	end
	return value
end


-- 返回 是否 参数1 的绝对值大于参数2的绝对值
function UnityTools.IsAbsBig(value1,value2)
	return UnityTools.Abs(value1)>UnityTools.Abs(value2)
end


--获得 以p1为原点 p2为相对原点坐标的角度
function UnityTools.GetAngleOfPositionOfV2(p1,p2)
	local diffx = p2.x-p1.x
	local diffy = p2.y-p1.y
	
	return UnityTools.GetAngleOfValueOfV2(diffx,diffy)
end

--获得 以p1为原点 p2为相对原点坐标的角度
function UnityTools.GetAngleOfValueOfV2(diffx,diffy)

	local a = LuaToUnityLogicManage.Atan2(diffx,diffy)
	a = a*Mathf.Rad2Deg
	return a
end

--添加一个button事件 用于 有按下效果
function UnityTools.SetButton(go,fun,soundName)
	--print("设置按钮UnityTools.SetButton"..go.name)
	local btn = go:GetComponent("UIButton")
	if(btn==nil) then
		btn = go:AddComponent(typeof(UIButton))
	end

	local btnColorR=1;
	local btnColorG=1;
	local btnColorB=1;

	btn.duration=0.05

	--鼠标放入 不用管
	--btn.hover = Color.New(btnColorR,btnColorG,btnColorB)


	--鼠标按下
	btn.pressed = Color.New(0.5,0.5,0.5)
	--鼠标无效 当 btn.enabled=false 时   btn.SetState(UIButtonColor.State,true)设置成无效状态 但是可以点击
	btn.disabledColor = Color.New(btnColorR,btnColorG,btnColorB)


	if(fun~=nil) then

		local newFun = function() 
			fun(go)
			if(soundName == nil) then
				AudioManage.PlayDefaultButton()
			else
				if soundName ~= AudioManage.NOT_SOUND then
					AudioManage:Play(soundName)
				end
			end
		end
		UIEventListener.Get(go).onClick = newFun;
	end

end

--添加click事件
function UnityTools.SetClick(go,fun,soundName)
	--print("设置按钮UnityTools.SetClick"..go.name)
	if(fun~=nil) then
		--print("fun != nil")
		local newFun = function() 
			--print("newFun logic")
			fun(go)
			if(soundName == nil) then
				AudioManage.PlayDefaultButton()
			else
				if soundName ~= AudioManage.NOT_SOUND then
					AudioManage:Play(soundName)
				end
			end
			
		end
		UIEventListener.Get(go).onClick = newFun;
	end

end

function UnityTools.SetClickNotAudio(go,fun)
	--UIEventListener.Get(go).onClick=fun
	UnityTools.SetClick(go,fun,soundName)
end
function UnityTools.SetButtonNotAudio(go,fun)
	UIEventListener.Get(go).onClick=fun
	UnityTools.SetButton(go,fun,soundName)
end

--设置 uibutton控件是否可用
function UnityTools.SetUIButtonEnable(btn,yn)
	local uibutton = btn.gameObject:GetComponent("UIButton")
	if(uibutton~=nil) then
		uibutton.isEnabled=yn
	end
end


-- 保留小数点自定义位数 n不填就是只要整数
function UnityTools.GetPreciseDecimal(num, n)
	return MathTools.GetPreciseDecimal(num, n)
end
--设置transform转 x,y,z度
function UnityTools.TransformEulerAngles(tf , x,y,z)
	LuaToUnityLogicManage.setTransformEulerAngles(tf,x,y,z)
end

--切分字符串 delimiter 是用哪个字符进行切割	--本方法必须保证最后一位是分割符 否则会少一位
--notNil 为真时 如果传入字符为空 或是""时  返回{} 而不是nil
function UnityTools.split(str, delimiter,notNil)


	if str==nil or str=='' or delimiter==nil then
		if(notNil) then
			return {}
		else
			return nil
		end
	end
	
    local result = {}

	if(string.sub(str,-1) ~= delimiter) then
		--如果最后一位不是分隔符 添加一下分隔符
		str = str..delimiter
	end

    for match in (str):gmatch("(.-)"..delimiter) do
        table.insert(result, match)
    end
    return result
end

--分和字符串
function UnityTools.splitOfHadDelimiter(str, delimiter,notNil)
    --return string.split(str,delimiter);
--end
--function UnityTools.splitLogic(str, delimiter)
	if str==nil or str=='' or delimiter==nil then
		if(notNil) then
			return {}
		else
			return nil
		end
	end
	
    local result = {}
    for match in (str..delimiter):gmatch("(.-)"..delimiter) do
        table.insert(result, match)
    end
    return result
end
--设置物品品质框 物体 及 品质
function UnityTools.SetPropQuality(go,quality)
	local sp = go.gameObject.transform:GetComponent("UISprite")
	quality = quality +1
	sp.spriteName = EquipQuality[quality]
end 

--设置图片的宽高 或是label
function UnityTools.SetDimensions(sprite,width,height)
	sprite:SetDimensions(width,height)
end

--设置图片的宽高 或是label
function UnityTools.SetDimensionsW(sprite,width)
	sprite:SetDimensions(width,sprite.height)
end

--设置图片的宽高 或是label
function UnityTools.SetDimensionsH(sprite,height)
	sprite:SetDimensions(sprite.width,height)
end

--返回是否是enable的gameObject
function UnityTools.IsActive(go)
	return go.activeSelf
end
--生成蒙版
function UnityTools.AddMask(parentGo)
	local maskGo = Util.LoadPrefab("Prefab/mask")
	local mask = parentGo.transform:Find("mask")
	if mask == nil then 
		local go =  NGUITools.AddChild(parentGo, maskGo)
		go.name = "clickBg"
		go.transform.localPosition = Vector3.New(0,0,0)
	end 
end 
--销毁蒙版
function  UnityTools.DestroyMask(parentGo)
	local maskGo = parentGo.gameObject.transform:Find("maskPanel")
	if maskGo ~=  nil then 
		destroy(maskGo.gameObject)
	end 
end 
--字符替换
function UnityTools.StringReplace(str,oldSubStr,newSubStr)
	return string.gsub(str,oldSubStr,newSubStr)
end


function UnityTools.SetActivityLogicShow(gameObject)
	--gameObject.transform.localScale = Vector3.one
	UnityTools.SetActivityLogic(gameObject,true)
end
function UnityTools.SetActivityLogicHide(gameObject)
	--gameObject.transform.localScale = Vector3.zero
	UnityTools.SetActivityLogic(gameObject,false)
end

function UnityTools.SetActivityLogic(gameObject,yn)
	--print("调用UnityTools.SetActivityLogic"..gameObject.name)
	if(yn) then
		
		--gameObject.transform.localPosition = Vector3.zero
		gameObject.transform.localScale = Vector3.one
		
	else
		gameObject.transform.localScale = UIEffectTools.MIN_SCALE
		--gameObject.transform.localPosition = UnityTools.farPosition
	end
	--print("对"..gameObject.name.."进行缩放")
end

--重置坐标  用于主UI 显示
function UnityTools.ResetActivityOfOnlyPosition(gameObject)
	gameObject.transform.localPosition = Vector3.zero
end

--移动坐标 用于主UI隐藏时减少 drawcall  用于动画 
function UnityTools.HideActivityOfOnlyPosition(gameObject)
	gameObject.transform.localPosition = UnityTools.farPosition
end

--以设置坐标的方式显示隐藏界面
function UnityTools.SetActiveOnlyPosition(gameObject,yn)
	if yn then
		gameObject.transform.localPosition = Vector3.zero
	else
		gameObject.transform.localPosition = UnityTools.farPosition
	end
end
--物体是否显示状态 用positionX来判断
function UnityTools.IsActiveSelfOfPosition(gameObject)
	return gameObject.transform.localPosition == Vector3.zero
end
--物体是否是显示的状态 用缩放来判断
function UnityTools.IsActiveSelf(gameObject)
	return gameObject.transform.localScale == Vector3.one
end
--设置fontData默认id
function UnityTools.SetFontDataDefalutId(lbl,defalutId)
	lbl:GetComponent("FontData").defalutId = defalutId
end
--设置fontdata
function UnityTools.SetFontData(lbl,fontType,subType)
	lbl:GetComponent("FontData"):SetFont(fontType,subType)
end
--设置 按钮类 子样式
function UnityTools.SetFontDataOfButton(lbl,subType)
	lbl:GetComponent("FontData"):SetFont(FontConstant.BUTTON_TYPE,subType)
end

--设置确认按钮
function UnityTools.SetFontDataOfButtonSure(lbl)
	lbl:GetComponent("FontData"):SetFont(FontConstant.BUTTON_TYPE,FontConstant.BUTTON_BE_SURE)
end

--设置红色取消按钮
function UnityTools.SetFontDataOfButtonCancel(lbl)
	lbl:GetComponent("FontData"):SetFont(FontConstant.BUTTON_TYPE,FontConstant.BUTTON_CANCLE)
end

--设置 描述类子样式
function UnityTools.SetFontDataOfDesc(lbl,subType)
	lbl:GetComponent("FontData"):SetFont(FontConstant.DESC_TYPE,subType)
end

--设置 描述类子样式
function UnityTools.SetFontDataOfHeroName(lbl,quality)
	lbl:GetComponent("FontData"):SetFont(FontConstant.DESC_TYPE,FontConstant.DESC_HERO_NAME_1-1+quality)
end

--设置按钮文件是否有效 无效为灰态  yn为nil 时 默认为设置灰 yn有效时 如果为真 表示不灰 那么defaultType有值时 表示 设置的样子 如果无值  默认设为确认状态
function UnityTools.SetFontDataOfButtonLblEanble(lbl,yn,defaultType)
	if(yn == nil) then
		UnityTools.SetFontDataOfButton(lbl,FontConstant.BUTTON_GRAY)
	else
		if(yn) then
			if(defaultType==nil) then
				UnityTools.SetFontDataOfButton(lbl,FontConstant.BUTTON_BE_SURE)
			else
				UnityTools.SetFontDataOfButton(lbl,defaultType)
			end
		else
			UnityTools.SetFontDataOfButton(lbl,FontConstant.BUTTON_GRAY)
			
		end
	end
end

--设置按钮文件是否有效 无效为灰态  yn为nil 时 默认为设置灰 yn有效时 如果为真 表示不灰 那么defaultType有值时 表示 设置的样子 如果无值  默认设为确认状态
function UnityTools.SetFontDataOfButtonEanble(button,yn,defaultType)
	local lbl = button.transform:Find("Label")
	UnityTools.SetFontDataOfButtonLblEanble(lbl,yn,defaultType)
end


--设置品质 参数是物品常量 及 图片sprite
function UnityTools.SetGoodsQuality(goods,qualitySprite)
	if(goods == nil) then
		qualitySprite.gameObject:SetActive(false)
	elseif(goods:IsEquip()) then
		qualitySprite.gameObject:SetActive(true)
		qualitySprite.spriteName = EquipQuality[goods:GetQuality()+1]
	else
		qualitySprite.gameObject:SetActive(false)
	end

end

--设置小背景图（用于发现界面上小背景框丢失时使用）
function UnityTools.SetSmallBg(sprite,name)
	if (name ~= nil) then
		sprite.spriteName = name
	end
end

--設置碰撞體大小
function UnityTools.SetBoxCollider(boxCollider,size,offset)
	 if(boxCollider ~= nil) then
		local collider = boxCollider.transform:GetComponent("BoxCollider")
		collider.size = size
		collider.center = offset
	 end
end

--截取字符串
function UnityTools.SubStringUTF8(str, startIndex, endIndex)
    if startIndex < 0 then
        startIndex = UnityTools.SubStringGetTotalIndex(str) + startIndex + 1;
    end

    if endIndex ~= nil and endIndex < 0 then
        endIndex = UnityTools.SubStringGetTotalIndex(str) + endIndex + 1;
    end

    if endIndex == nil then 
        return string.sub(str, UnityTools.SubStringGetTrueIndex(str, startIndex));
    else
        return string.sub(str, UnityTools.SubStringGetTrueIndex(str, startIndex), UnityTools.SubStringGetTrueIndex(str, endIndex + 1) - 1);
    end
end

--获取中英混合UTF8字符串的真实字符数量
function UnityTools.SubStringGetTotalIndex(str)
    local curIndex = 0;
    local i = 1;
    local lastCount = 1;
    repeat 
        lastCount = UnityTools.SubStringGetByteCount(str, i)
        i = i + lastCount;
        curIndex = curIndex + 1;
    until(lastCount == 0);
    return curIndex - 1;
end

function UnityTools.SubStringGetTrueIndex(str, index)
    local curIndex = 0;
    local i = 1;
    local lastCount = 1;
    repeat 
        lastCount = UnityTools.SubStringGetByteCount(str, i)
        i = i + lastCount;
        curIndex = curIndex + 1;
    until(curIndex >= index);
    return i - lastCount;
end

--返回当前字符实际占用的字符数
function UnityTools.SubStringGetByteCount(str, index)
    local curByte = string.byte(str, index)
    local byteCount = 1;
    if curByte == nil then
        byteCount = 0
    elseif curByte > 0 and curByte <= 127 then
        byteCount = 1
    elseif curByte>=192 and curByte<=223 then
        byteCount = 2
    elseif curByte>=224 and curByte<=239 then
        byteCount = 3
    elseif curByte>=240 and curByte<=247 then
        byteCount = 4
    end
    return byteCount;
end