﻿--小跟班的常量数据管理
PetDataDicSystem = {}
--小跟班的所有数据
PetDataDicSystem.allItems = {}
-- 获得口粮的途径
PetDataDicSystem.getPowerStr = ""

--获得所有小跟班的数据
function PetDataDicSystem:GetAllPetsitems()
        return self.allItems
end 
--放入数据
function PetDataDicSystem:PutPetItemData(item)
     table.insert( self.allItems, item)
end 
--根据 小跟班id  获得 具体的 小跟班项
function PetDataDicSystem :GetPetDicItemOfId( petId)
        for   k,v in pairs(PetDataDicSystem.allItems) do 
            if v.petId == petId then
                return v
                    -- body
            end            
        end 
        --logError("获得常量出错 是空"..petId)
        return nil
end 

--根据 小跟班 碎片 id  获得 具体的 小跟班项
function PetDataDicSystem .GetPetDicItemOfPieceId( pieceId)
        for   k,v in pairs(PetDataDicSystem.allItems) do 
            if v.pieceId == pieceId then
                return v
                    -- body
            end            
        end 
        --logError("获得常量出错 是空"..petId)
        return nil
end 

--根据 小跟班 碎片 id  获得 具体的 小跟班ID
function PetDataDicSystem.GetPetIDOfPieceId( pieceId)
        for   k,v in pairs(PetDataDicSystem.allItems) do 
            if v.pieceId == pieceId then
                return v.petId
                    -- body
            end            
        end 
        --logError("获得GetPetIDOfPieceId常量出错 是空"..pieceId)
        return 0
end 

--根据跟班ID 获得技能 icon的名字
function PetDataDicSystem.GetPetSkillIDOfPetId(petId)

        --logError("PetDataDicSystem.GetPetSkillIDOfPetId".." petid"..petId.." : "..PetDataDicSystem:GetPetDicItemOfId(petId).skillId)
        return PetDataDicSystem:GetPetDicItemOfId(petId).skillId;

end

--获得品质
function PetDataDicSystem.GetPetLvOfPetId(petId)
        --logError("获得品质" .. PetDataDicSystem:GetPetDicItemOfId( petId).petRare)
        return PetDataDicSystem:GetPetDicItemOfId( petId).petRare
end

--根据 小跟班 id  获得 具体的 小跟班名字
function PetDataDicSystem.GetPetNameOfPetId( petId)
        for   k,v in pairs(PetDataDicSystem.allItems) do 
            if v.petId == petId then
                return v.petName
                    -- body
            end            
        end 
        --logError("获得GetPetNameOfpetId常量出错 是空"..petId)
        return ""
end

-- 根据petID 返回所在index 如果没有 默认返回1 如果想默认返回其他值,请赋给第二个参数
function PetDataDicSystem:GetIndexOfPetID( petId,defaultIndex)
        for   k,v in ipairs(self.allItems) do 
            if v.petId == petId then
                return k
                    -- body
            end            
        end 
        if(defaultIndex~=nil) then
                return defaultIndex
        end
        return 1
        
end 

--根据 小跟班id  获得 具体的 小跟班项
function PetDataDicSystem :GetPetDicItemOfIndex( index)
        return self.allItems[index]
end 

--初始化数据
function PetDataDicSystem:InitData()
        local jsonTable = JsonManage:GetTableItemOfName(JsonConstant.PET_CONFIG)
        local jsonList = jsonTable:GetJsonTable()
        local petDicItem = nil     
        for key, var in pairs(jsonList) do 
                petDicItem = PetDataDicItem.New()
                petDicItem.petId = var.petId 
                
                petDicItem.skillId = var.skills
                petDicItem.desc = var.desc 
                petDicItem.petName = var.petName
                --print("petDicItem.petName===="..petDicItem.petName)
                petDicItem.petModleName = var.petModleName
                petDicItem.petHeadSp = var.petHeadSpName
                petDicItem.petBadyName = var.petBadyName
                petDicItem.petRare = var.petRare
                petDicItem.petPowerMax = var.petPowerMax
                self:PutPetItemData(petDicItem)
                
        end

        local jsonTable = JsonManage:GetTableItemOfName(JsonConstant.PET_PIECE_CONFIG)
        local jsonList = jsonTable:GetJsonTable()
        local petPieceDicItem = nil     

        for k, var in pairs(jsonList) do 
                petDicItem = self:GetPetDicItemOfId( var.petId)
                petDicItem.pieceId = var.pieceId
                petDicItem.pieceComboNum = var.pieceNum
        end

end

--用于c#调用时,如果要移除不再学这个技能的等方面,就返回修正后的值
function PetDataDicSystem.GetRemoveLogicSkill(skillID)
local removeSkill={14,21,151,24,71,23}
if(skillID>=10000) then
        --return  skillID-10000
        for i,v in ipairs (removeSkill) do
        if(v == skillID) then
                return skillID - 10000
        end
        end

        return skillID;
else
        return skillID
end
end

    -- 用于c#调用时的逻辑转换
function PetDataDicSystem.GetChangeSkill(skillID)
        if(skillID>=10000) then
                return  skillID-10000

                --return 71
        else
                return skillID
        end
end


--获得当前是否拥有小跟班
function PetDataDicSystem.GetPetHaveHas()
			  local varItem =  PetDataDicSystem:GetPetDicItemOfId(4015)
			  if	varItem:IsLock() then 
				return tonumber(0)
			  else
					return tonumber(1)
			  end 
			 	return tonumber(0)
end 
--当前选择的小跟id 
function PetDataDicSystem.GetCurChoosePetId()
        return  tonumber( UnityEngine.PlayerPrefs.GetString("localChoosePetId","0")) 
     end 
--当前小跟班的技能
function PetDataDicSystem:GetCurChoosePetSkillId()
        
        if PetDataDicSystem:IsUsePet () then
                return   PetDataDicSystem:GetPetDicItemOfId(PetDataDicSystem:GetCurChoosePetId()).skillId
        end
        return -1
end 

--获得当前 选择的小跟班的模型名称
function PetDataDicSystem.GetChoosePetModelName()
        if PetDataDicSystem:IsUsePet()==false then
                return ""
        end
        local varItem =  PetDataDicSystem:GetPetDicItemOfId(PetDataDicSystem:GetCurChoosePetId())
        if varItem ~=nil then
                return varItem.petModleName 
        end
        return ""
end 

--获得指定 的小跟班的模型名称
function PetDataDicSystem.GetChoosePetModelNameOfPetID(petID)
        if PetDataDicSystem:IsUsePet()==false then
                return ""
        end
        local varItem =  PetDataDicSystem:GetPetDicItemOfId(petID)
        if varItem ~=nil then
                return varItem.petModleName 
        end
        return ""
end 

--设置当前的小跟班id 
function PetDataDicSystem:SetCurPet (petId)
        UnityEngine.PlayerPrefs.SetString("localChoosePetId",""..petId);
end 
function PetDataDicSystem:SetCurPetOfTest (petId)
        UnityEngine.PlayerPrefs.SetString("localChoosePetId",""..petId);
end 
--卸下小跟班
function PetDataDicSystem:ClearPet ()
        UnityEngine.PlayerPrefs.SetString("localChoosePetId",""..0);
end 
--是否使用了小跟班
function PetDataDicSystem:IsUsePet ()
        local petId =  tonumber( UnityEngine.PlayerPrefs.GetString("localChoosePetId","0")) 
        if petId > 0 then
         return true
        end
        return false
end 

function PetDataDicSystem.UnLockPet (petID)
        --logError("解锁小跟班" .. petID)
        PetDataDicSystem:GetPetDicItemOfId(petID):ClearLock()
end
--设置小跟班的体力
function PetDataDicSystem.SetCurPetPower(petId,power)
      local item =  PetDataDicSystem :GetPetDicItemOfId( petId)
        if item ~= nil  then
                item.power = power
        end
end 
--根据小跟班id 获得具体小跟班能量数据
function PetDataDicSystem.GetPetPowerData(petId)
        if PetDataDicSystem:GetPetDicItemOfId( petId)  ==  nil  then
                return 0,20
        end
       return   PetDataDicSystem :GetPetDicItemOfId( petId) .power , PetDataDicSystem:GetPetDicItemOfId( petId) .petPowerMax
end 
-- 用于unity 调用 
function PetDataDicSystem.GetPowerMatchStr()
        return PetDataDicSystem.getPowerStr
end 
--根据小跟班的 碎片id 获得 跟班的名字
function PetDataDicSystem.GetPetNameByPieceId(pieceId)
       local petId = PetDataDicSystem.GetPetIDOfPieceId( pieceId)
       local petName =  PetDataDicSystem.GetPetNameOfPetId( petId)
       return petName 
end
--用于unity掉用,得到拥有碎片最多的碎片id
function PetDataDicSystem.GetMostPiceId()
        local jsonTable = JsonManage:GetTableItemOfName(JsonConstant.PET_PIECE_CONFIG)
        local jsonList = jsonTable:GetJsonTable()
        --先去掉黑名单的id
        local i = 1
        while i <= #jsonList do
                local pieceId = jsonList[i].pieceId
                if  BattleRewardData.Instance():ContainedInList(pieceId) then
                        table.remove(jsonList, i)
                else
                        i = i + 1
                end
        end
        local pieceItemList = {}
        for key,var in pairs(jsonList)do
                local minPieceId = jsonList[key].pieceId
                local minPieceItem = jsonList[key]
                for k,v in pairs(jsonList) do
                        if minPieceId > v.pieceId then
                                minPieceId = v.pieceId
                        end
                end
                table.insert(pieceItemList,minPieceItem )
        end

        for k,v in pairs(pieceItemList)do
               -- logError("第"..tostring(k).."个碎片的id是.................."..tostring(v.pieceId))
        end

        local targetPieceId = nil
        local maxPieceid = jsonList[1].pieceId
        local maxPieceNum = PropVarDataManger.Instance:GetPropVarCountOfPropId(maxPieceid)
        for k,v in pairs(jsonList) do
                local tempPieceId =  v.pieceId
                local tempComboNum = v.pieceNum
                local tempPieceNum = PropVarDataManger.Instance:GetPropVarCountOfPropId(tempPieceId)
                local tempPetItem =   PetDataDicSystem .GetPetDicItemOfPieceId(tempPieceId)--当前小跟班
                if (tempComboNum == tempPieceNum) or (tempPetItem.isLock == false)  then
                        --如果碎片数满足合成 或 对应的小跟班已经解锁
                else
                        --碎片数量不满足合成
                        if tempPieceNum >maxPieceNum then
                                maxPieceid = tempPieceId
                                maxPieceNum = tempPieceNum
                        end
                end
        end
        targetPieceId = maxPieceid
        logError("发给玩家的跟班碎片id 是====="..tostring(targetPieceId))
        return targetPieceId
end
