--转盘物品常量
RotaryItemData = {}

RotaryItemData.allItem = {}

function RotaryItemData.New()
    local item = {}
    --物品 id
    item.id = nil
    --物品在转盘的index
    item.indexId = nil
    --物品数量
    item.num = nil
    --物品是否已领取
    item.hasGot = false
    --转盘结束物品的changeValue
    item.changeValue = nil
    --转盘物品的finalValue
    item.finalValue = nil
    --转盘物品的详细描述
    item.info = nil
    --该物品是否是一个buff
    item.isBuff = nil
    
    return item

end 

--放入数据
function RotaryItemData:PutRotaryItemData(item)
    table.insert(RotaryItemData.allItem,item)
end
--根据id获得item
function RotaryItemData:GetItemById(itemId)
    for k,v in pairs(RotaryItemData.allItem) do
        if v.id == itemId then
            return v
        end
    end
    return nil
end
--根据物品index获得item
function RotaryItemData:GetItemByIndex(itemIndex)
    for k,v in pairs(RotaryItemData.allItem) do
        if v.indexId == tostring( itemIndex) then
            return v
        end
    end
    return nil
end
--根据物品index获得七id
function RotaryItemData:GetIdByIndex(itemIndex)
    for k,v in pairs(RotaryItemData.allItem) do
        if v.indexId == itemIndex then
            return v.id
        end
    end
    return nil
end
--设置index物品的changeValue和finalValue
function RotaryItemData.SetValuesByIndex(itemIndex,_changeValue,_finalValue)
    for k,v in pairs(RotaryItemData.allItem) do
        if v.indexId == itemIndex then
            v.changeValue = _changeValue
            v.finalValue = _finalValue
        end
    end
end
--获得index物品的changeValue
function RotaryItemData:GetChangeValueByIndex(itemIndex)
    for k,v in pairs(RotaryItemData.allItem) do
        if v.indexId == itemIndex then
            return v.changeValue
        end
    end 
    return nil
end
--获得index物品的finalValue
function RotaryItemData:GetFinalValueByIndex(itemIndex)
    for k,v in pairs(RotaryItemData.allItem) do
        logError("allItem:"..k.."==="..v)
        if v.indexId == itemIndex then
            return v.finalValue
        end
    end 
    return nil
end
--根据物品index获得七id
function RotaryItemData:GetIdByIndex(itemIndex)
    for k,v in pairs(RotaryItemData.allItem) do
        if v.indexId == itemIndex then
            return v.id
        end
    end
    return nil
end
--设置index物品的changeValue和finalValue
function RotaryItemData.SetValuesByIndex(itemIndex,_changeValue,_finalValue)
    for k,v in pairs(RotaryItemData.allItem) do
        if v.indexId == itemIndex then
            v.changeValue = _changeValue
            v.finalValue = _finalValue
        end
    end
end
--获得index物品的changeValue
function RotaryItemData:GetChangeValueByIndex(itemIndex)
    for k,v in pairs(RotaryItemData.allItem) do
        if v.indexId == itemIndex then
            return v.changeValue
        end
    end 
    return nil
end
--获得index物品的finalValue
function RotaryItemData:GetFinalValueByIndex(itemIndex)
    for k,v in pairs(RotaryItemData.allItem) do
        --logError("allItem:"..k.."==="..v)
        if v.indexId == itemIndex then
            return v.finalValue
        end
    end 
    return nil
end
--进游戏从40协议初始化数据
function RotaryItemData.InitDataPerDay(_remainRotaryTimes)
    RotaryItemData.allItem = {}
    local allItem = UnityEngine.PlayerPrefs.GetString("RotaryItem")
    if allItem ~= nil then
        --logError(""..allItem)
        local rotaryList = string.split(allItem,",")
        local _item = nil
        for k,v in pairs(rotaryList) do
            local array  = {0,0,0}
            local info = string.split(v,":")
            _item = RotaryItemData.New()
            if _item ~= nil then
                _item.indexId = info[1]
                _item.id = info[2]
                _item.num = info[3]
                --logError("InitDataPerDay--".._item.indexId.."================".._item.id.."==================".._item.num )
                RotaryItemData:PutRotaryItemData(_item)
            end
        end
        RotaryPanel.remainRotaryTimes = _remainRotaryTimes
        --UnityEngine.PlayerPrefs.SetString("MaxRotaryTimes",tostring(_remainRotaryTimes))
        --RotaryItemData:InitItemState()
    end
end

--清除本地的物品领取状态
function RotaryItemData.InitItemState()
    for i = 1, 8 do 
        UnityEngine.PlayerPrefs.SetInt("RotaryItem"..tostring(i),0)
    end
end


