﻿--主界面的控制
ViewLoginPanel = {}
ViewLoginPanel.gameObject = nil 
--loginPnael节点
ViewLoginPanel.panelParent = nil;

ViewLoginPanel.taskBtn = nil 

ViewLoginPanel.addTestStarBtn = nil 
--玩家头像
ViewLoginPanel.headSprite = nil;
--玩家头像框
ViewLoginPanel.borderSprite = nil;
--赛季奖励按钮
ViewLoginPanel.qualifyRewardBtn = nil;
--赛季奖励按钮上的 宝箱提示 有可领取的奖励 会显示
ViewLoginPanel.qualifyRewardBtnBox = nil;
--选择头像框提示特效
ViewLoginPanel.headBorderTipsEffect = nil;
--选择头像框提示手指
ViewLoginPanel.headBorderTipsHand = nil;
--是否需要显示头像框功能提示特效
ViewLoginPanel.isNeedShowBorderTipEffect = nil;
--是否需要显示头像框功能提示特效 存本地的key值  1为需要显示 0为不需要
ViewLoginPanel.SHOW_BORDER_EFFECT_LOCAL_KEY ="SHOW_BORDER_EFFECT_LOCAL_KEY";
--新获得头像框提示红点
ViewLoginPanel.borderRedDot = nil;
--转盘的红点
ViewLoginPanel.rotaryRedDot = nil;

ViewLoginPanel.writeBigEffectTime = "writeBigEffectTimeNew1"
ViewLoginPanel.isCLickTaskPanel=  "isClickNewTaskPanel1"

--当前的星星数的显示
ViewLoginPanel.curStarNumsLb = nil 
function  ViewLoginPanel.Awake(go)
    ViewLoginPanel.gameObject  = go    
    ViewLoginPanel.panelParent = go.transform.parent.gameObject;
    ViewLoginPanel.isNeedShowBorderTipEffect = UnityEngine.PlayerPrefs.GetInt(ViewLoginPanel.SHOW_BORDER_EFFECT_LOCAL_KEY,1) == 1;    
end


function  ViewLoginPanel.Start()

 --同步奖励项领取状态 和星星
 
    
    ViewLoginPanel.taskBtn = ViewLoginPanel.gameObject.transform:Find("taskBtn").gameObject
    -- UnityTools.SetButton(go,function()  LoginPanel.OpenTaskPanel()  end )
    UIEventListener.Get(ViewLoginPanel.taskBtn).onClick = function()  ViewLoginPanel.OpenTaskPanel()  end 

    ViewLoginPanel.addTestStarBtn = ViewLoginPanel.gameObject.transform:Find("addBtn").gameObject

     UIEventListener.Get(ViewLoginPanel.addTestStarBtn).onClick = function()  ViewLoginPanel.TestAddStarLogic()  end     
    ViewLoginPanel.headSprite = ViewLoginPanel.panelParent.transform:Find("InputName/headBox"):GetComponent("UISprite");
    ViewLoginPanel.borderSprite = ViewLoginPanel.headSprite.transform:Find("headSp"):GetComponent("UISprite");    
    UIEventListener.Get(ViewLoginPanel.headSprite.gameObject).onClick = function() ViewLoginPanel.ClickHead(); end;
    ViewLoginPanel.qualifyRewardBtn = ViewLoginPanel.gameObject.transform:Find("rewardBtn").gameObject;
    UIEventListener.Get(ViewLoginPanel.qualifyRewardBtn).onClick = function() ViewLoginPanel.ClickQualifyRewardBtn(); end;
    ViewLoginPanel.curStarNumsLb =  ViewLoginPanel.gameObject.transform:Find("rewardBtn/Sprite/starNums/numsSp/Label"):GetComponent("UILabel")
    ViewLoginPanel.headBorderTipsEffect = ViewLoginPanel.headSprite.transform:Find("Particle System").gameObject;
    ViewLoginPanel.headBorderTipsHand = ViewLoginPanel.headSprite.transform:Find("hand").gameObject;
    ViewLoginPanel.qualifyRewardBtnBox = ViewLoginPanel.qualifyRewardBtn.transform:Find("Sprite/boxSprite").gameObject;
    ViewLoginPanel.borderRedDot = ViewLoginPanel.headSprite.transform:Find("redDot").gameObject; 
    HeadBorderDataManager:GetHeadBorderData();
    ViewLoginPanel:RefreshCurBorerSprite();
    ViewLoginPanel.RefreshCurHeadSprite();
    ViewLoginPanel.ShowBigEffect()
    --刷新头像框提示特效
    ViewLoginPanel.RefreshBorderTipEffect();
    --刷新赛季奖励可领的 宝箱提示
    ViewLoginPanel.RefreshQualifyRewardBtnEffect()
     --刷新新头像框提示红点
    ViewLoginPanel.RefreshBorderRedDot()

    ViewLoginPanel.rotaryRedDot = ViewLoginPanel.panelParent.transform:Find("Container/theatre/times").gameObject;
end 
--显示转盘红点,收到40协议后设置显示
function ViewLoginPanel.ShowRotaryRedDot()
    logError("第一一次进游戏显示红点==================================================")
    if ViewLoginPanel.rotaryRedDot ~= nil then
        ViewLoginPanel.rotaryRedDot:SetActive(true)
    end
end

function  ViewLoginPanel.TestAddStarLogic()
    local taskType = NetConfig.HttpTaskType.Test
    local param = JsonObject.New()
     param:encode("","")
      local luaClass = "ViewLoginPanel"
    local luaFun = "AddStarData"
    GzNet.Call(taskType,param,luaClass,luaFun)
end 

function ViewLoginPanel.AddStarData(_netData)
    local taskType = NetConfig.HttpTaskType.HttpTaskType_Get_Qualify_Reward
    local param = JsonObject.New();
    param:encode("isLogin","0")
    local luaClass = "QualifyRewardVarDataManager"
    local luaFun = "NetCallBack"
    GzNet.Call(taskType,param,luaClass,luaFun)
    UIManager.showLoading(true)
end 

--任务按钮点击事件
function ViewLoginPanel.OpenTaskPanel()
    if(InitDataProtocalManager.IsSyncFinished()) then
        --查看任务列表事件
        GzTK.TKEvent(TalkingDataConst.TKE_CLICK_TASK_LIST);
        if(ViewLoginPanel.panelParent ~= nil) then
        ViewLoginPanel.SendGetTaskProgress()
        UIManager.showLoading(true)
        end      
    end
end 
--发送270  获得 任务完成进度的 协议
function ViewLoginPanel.SendGetTaskProgress()     
    local taskType = NetConfig.HttpTaskType.HttpTaskType_Get_Task_Progress
    local param = JsonObject.New()
    local hasAd = UserDataManager.IsChannelHasAd();
    local isAdChannel = 0
    if hasAd then
        isAdChannel = 1
    else  
        isAdChannel = 0
    end
    param:encode("isAdChannel",isAdChannel)
    
    local luaClass = "ViewLoginPanel"
    local luaFun = "GetTaskNetData"
    GzNet.Call(taskType,param,luaClass,luaFun)         
end 
function ViewLoginPanel.GetTaskNetData(_netData)

        TaskFunctionData:SetNetData(_netData)
        UIManager.showLoading(false) 
        --如果当前面板中没有此面板  再打开 因为出现过打开两个的情况
        if (UIManager.GetUI("ViewQuestPanel") == nil) then
            UIManager.CreateUIOfLua("ViewQuestPanel") 
        end
end 
--点击头像框
function ViewLoginPanel.ClickHead()
    if(InitDataProtocalManager.IsSyncFinished()) then
        --点击头像框事件
        GzTK.TKEvent (TalkingDataConst.TKE_CLICK_HEAD_BORDER);
        UIManager.CreateUIOfLua("SelectHeadBorderPanel");
        if(ViewLoginPanel.IsNeedShowBorderTipEffect()) then--点过一次头像框之后 记为不需要显示头像框提示特效
            ViewLoginPanel:SetNoNeedShowBorderTip();
            ViewLoginPanel.RefreshBorderTipEffect();
        end
         if(HeadBorderDataManager.IshaveNewBorder()) then --如果当前有新获得的头像框
            HeadBorderDataManager.SetHaveNewBorder(false); --打开了一次就设置为没有新获得的头像框
            ViewLoginPanel.RefreshBorderRedDot();           --刷新红点显示
        end
    end
end
--点击赛季奖励按钮
function ViewLoginPanel.ClickQualifyRewardBtn()
    if(InitDataProtocalManager.IsSyncFinished()) then
        --点击赛季奖励按钮的事件
        GzTK.TKEvent(TalkingDataConst.TKE_CLICK_QUALIFY_REWARD);
        UIManager.CreateUIOfLua("QualifyRewardPanel");
    end
end
--刷新当前选择的头像框
function ViewLoginPanel:RefreshCurBorerSprite()
    if(self.panelParent ~= nil and self.borderSprite ~= nil) then
        local curBorderId = HeadBorderDataManager.GetCurBorderId();
        HeadBorderDataManager.SetSpriteByBorderId(self.borderSprite,curBorderId);
    end
end
--刷新当前选择的英雄头像
function ViewLoginPanel.RefreshCurHeadSprite()
    if(ViewLoginPanel.panelParent ~= nil) then       
        local curHeroId = UserDataManager.Instance:getSkinId();
        local skinItem = LoadSkill.getSkinItemConfigOfKey(curHeroId);
        --英雄资源id 用来显示头像
        local resId = tonumber(skinItem.skinId);
        GzLoadAtlasManager.Instance:SetHeadSprite(ViewLoginPanel.headSprite,"char_"..resId);
    end
end
--设置主界面的当前的星星显示
function ViewLoginPanel.ShowStarNums()
		if  (ViewLoginPanel.gameObject~= nil ) then 
			ViewLoginPanel.curStarNumsLb.text = QualifyRewardVarDataManager:GetCurStarProcess()
		end
	--	ViewLoginPanel.curStarNumsLb =  ViewLoginPanel.gameObject.transform:Find("rewardBtn/Sprite/starNums/numsSp/Label"):GetComponent("UILabel")
end 
--请求当前的星星数
function  ViewLoginPanel.SendGetCurStar()
    local taskType = NetConfig.HttpTaskType.HttpTaskType_Get_Cur_Star_Nums
    local param = JsonObject.New()  
    local luaClass = "ViewLoginPanel"
    local luaFun = "Get273ProCallBack"
    GzNet.Call(taskType,param,luaClass,luaFun)
end 
-- 273协议返回
function ViewLoginPanel.Get273ProCallBack(_netdata)
     local data = tools_Cjson.decode (_netdata._data)
     if data ~= nil  then
     -- print("273协议返回273协议返回273协议返回273协议返回273协议返回================222222222222"..data.data.rewardStar)
       if data.data ~=nil then
         
              QualifyRewardVarDataManager:SetStarNum(data.data.rewardStar)
              ViewLoginPanel.ShowStarNums()
       end
     end
end 
--显示放大镜
function ViewLoginPanel.ShowBigEffect()
    local bigEffect =  ViewLoginPanel.gameObject.transform:Find("taskBtn/Sprite/bigEffect").gameObject
    local isShow=  UnityEngine.PlayerPrefs.GetString(ViewLoginPanel.writeBigEffectTime,"")
    local isClick = UnityEngine.PlayerPrefs.GetInt(ViewLoginPanel.isCLickTaskPanel,0)
    local curHour = os.date("*t", os.time()).hour 
    local curTime  = os.date("%x")
    if isShow == ""  then
        bigEffect:SetActive(true)
      
 
        local str= curTime..","..curHour..","
        UnityEngine.PlayerPrefs.SetString(ViewLoginPanel.writeBigEffectTime,str)
        UnityEngine.PlayerPrefs.SetInt(ViewLoginPanel.isCLickTaskPanel,0)
        -- body
    else  
        local lastTime  = UnityEngine.PlayerPrefs.GetString(ViewLoginPanel.writeBigEffectTime,"")
        local result = {}
        string.gsub(lastTime,'[^'..","..']+',function ( w )
              table.insert(result,w)
         end)
        -- print("上一次的日期 是======= "..result[1].."上一次的小时数"..result[2].."当前的标志位是===="..isClick)
        if isClick == 0  then
              bigEffect:SetActive(true)
        else    
            if curTime ~= result[1]  then
                if tonumber(curHour) >=5 then
                    -- body
                    bigEffect:SetActive(true)
                    UnityEngine.PlayerPrefs.SetInt(ViewLoginPanel.isCLickTaskPanel,0)
                else  
                    bigEffect:SetActive(false)
                end
            else
                if  tonumber( result[2]) >=5 then 
                      bigEffect:SetActive(false)
                else
                    if tonumber(curHour) >=5 then
                        bigEffect:SetActive(true)
                        UnityEngine.PlayerPrefs.SetInt(ViewLoginPanel.isCLickTaskPanel,0)
                    end
                end 
               
            end
        end
        local wTime  = os.date("%x")
        local whour = os.date("*t", os.time()).hour 
        local str= wTime..","..whour..","
        UnityEngine.PlayerPrefs.SetString("needBigEffectTime",str)
        --print("z这一次的日期 是======= "..wTime.."这一次的小时数"..whour.."当前的标志位是===="..isClick)
    end
  
end 
--设置为当前不需要显示提示头像框特效
function ViewLoginPanel:SetNoNeedShowBorderTip()
    self.isNeedShowBorderTipEffect = false;
    UnityEngine.PlayerPrefs.SetInt(self.SHOW_BORDER_EFFECT_LOCAL_KEY,0);
end
--是否需要显示头像框提示特效
function ViewLoginPanel.IsNeedShowBorderTipEffect()
    if(ViewLoginPanel.isNeedShowBorderTipEffect == nil) then        
        ViewLoginPanel.isNeedShowBorderTipEffect = UnityEngine.PlayerPrefs.GetInt(SHOW_BORDER_EFFECT_LOCAL_KEY,1) == 1;
        return ViewLoginPanel.isNeedShowBorderTipEffect;
    else
        return ViewLoginPanel.isNeedShowBorderTipEffect;
    end
end
--刷新选择头像框提示特效限时
function ViewLoginPanel.RefreshBorderTipEffect()
    if(ViewLoginPanel.panelParent ~= nil and ViewLoginPanel.headBorderTipsEffect ~= nil) then
        if(UIManager.GetStackTopUIType() == UIType.UI_Start) then --如果顶部面板是主界面 就可以显示提示特效            
            if(ViewLoginPanel.IsNeedShowBorderTipEffect()) then
                ViewLoginPanel.headBorderTipsEffect:SetActive(true);
                ViewLoginPanel.headBorderTipsHand:SetActive(true);
            else            
                ViewLoginPanel.headBorderTipsEffect:SetActive(false);
                ViewLoginPanel.headBorderTipsHand:SetActive(false);
            end            
        else
                ViewLoginPanel.headBorderTipsEffect:SetActive(false);
                ViewLoginPanel.headBorderTipsHand:SetActive(false);
        end        
    end
end
function ViewLoginPanel.ClearEffectKey()
    UnityEngine.PlayerPrefs.DeleteKey(ViewLoginPanel.SHOW_BORDER_EFFECT_LOCAL_KEY);
end

function ViewLoginPanel.OnDestroy()
    ViewLoginPanel.panelParent = nil;
    ViewLoginPanel.headBorderTipsEffect = nil;
    ViewLoginPanel.qualifyRewardBtnBox = nil;
    ViewLoginPanel.borderRedDot = nil;
    ViewLoginPanel.borderSprite = nil
end
--刷新 赛季奖励按钮上宝箱的显示  有可领取的物品就显示
function ViewLoginPanel.RefreshQualifyRewardBtnEffect()      
    if(ViewLoginPanel.panelParent ~= nil and ViewLoginPanel.qualifyRewardBtnBox ~= nil) then        
        --同步是否完成
        if(InitDataProtocalManager.IsSyncFinished()) then           
            --是否有奖励可领
            local canReceiveReward = QualifyRewardVarDataManager.HaveRewardCanReceive();
            ViewLoginPanel.qualifyRewardBtnBox:SetActive(canReceiveReward);
        else        
            ViewLoginPanel.qualifyRewardBtnBox:SetActive(false);
        end       
    end
end
--刷新主界面 选择头像框红点
function ViewLoginPanel.RefreshBorderRedDot()
      if(ViewLoginPanel.panelParent ~= nil and ViewLoginPanel.borderRedDot ~= nil) then
        ViewLoginPanel.borderRedDot:SetActive(HeadBorderDataManager.IshaveNewBorder());
      end    
end