--任务功能数据系统管理
TaskFunctionData = {}
--任务刷新时间
TaskFunctionData.questListUpdateTime =  ""
--了几滴按摩瑟吉欧发票上那片懒黄哈皮的手机开 0不上报 1上报
TaskFunctionData.isAdReport = -1
--周任务列表
TaskFunctionData.weekQuestList = {}
--日任务列表
TaskFunctionData.dayQuestList = {}
--任务完成状态
TaskFunctionData.STA_TASK_OVER = 1
--任务未完成状态
TaskFunctionData.STA_TASK_NO = 0
--协议数据
TaskFunctionData._netData = nil
--是否需要看广告
TaskFunctionData.isAdd = 1
--看广告的 Id
TaskFunctionData.lastLookAdsTaskId = 0
--获得所有周任务列表
function TaskFunctionData:GetAllWeekendTasks()
    local allTasks= {}
    for k,v in pairs( self.weekQuestList) do 
            if v.questStatus ==  TaskFunctionData.STA_TASK_NO then
               table.insert( allTasks, v )
            end
    end 
    for k,v in pairs(self.weekQuestList) do 
         if v.questStatus ==  TaskFunctionData.STA_TASK_OVER then
               table.insert( allTasks, v )
            end
    end  
        return allTasks
end 
--获得所有日任务列表
function TaskFunctionData:GetAllDayTasks()
     local allTasks= {}
    for k,v in pairs( self.dayQuestList) do 
            if v.questStatus ==  TaskFunctionData.STA_TASK_NO then
               table.insert( allTasks, v )
            end
    end 
    for k,v in pairs(self.dayQuestList) do 
         if v.questStatus ==  TaskFunctionData.STA_TASK_OVER then
               table.insert( allTasks, v )
            end
    end  
        return allTasks
end 
--放入周任务列表数据
function TaskFunctionData:PutWeekendTaskItem(weekendTaskItem)
    table.insert(self.weekQuestList,weekendTaskItem)
end 
--放入日任务列表数据
function TaskFunctionData:PutDayTaskItem(dayTaskItem)
      table.insert(self.dayQuestList,dayTaskItem)
end 

--根据周任务Id 获得 对应周任务
function TaskFunctionData:GetWeekendTaskOfKey(weekendTaskId)
    for  k,v in pairs(self.weekQuestList) do 
        if      v:GetKey() == weekendTaskId then 
            return v
        end 
    end 
    return nil 
end 
--根据 日任务Id获得 对应日任务
function  TaskFunctionData:GetDayTaskOfKey(dayTaskId)
    for k,v in pairs(self.dayQuestList)  do 
            if v:GetKey() == dayTaskId then 
                return v 
            end 
    end 
    return nil 
end 
-- 判断当前是日任务 还是 周任务
function  TaskFunctionData:CurTaskIsDayOrWeekendOfKey(questId)
        local  taskItem = TaskFunctionData:GetWeekendTaskOfKey(questId)
        if  taskItem  ~=  nil then 
            return  2
        else
            taskItem =   TaskFunctionData:GetDayTaskOfKey(questId)
            if  taskItem~= nil then 
                return 1
            end 
        end 
        return nil 
end 
--接受数据
function TaskFunctionData:SetNetData(_netData)
         self._netData = _netData
         --周任务列表
        self.weekQuestList = {}
        --日任务列表
        self.dayQuestList = {}
      local data = tools_Cjson.decode (_netData._data)
    if data.data ~= nil  then
       if data.data.questData ~= nil  then

             TaskFunctionData.isAdd = data.data.questData.isAdReport
           --  print(" data.data.questData.isAdReport==========".. data.data.questData.isAdReport)
          --   print( data.data.questData.isAdReport == 1)
            -- print( data.data.questData.isAdReport == "1")
            for k,v in pairs (data.data.questData.weekQuestList)  do 
                local wItem  = WeekendTaskItem.New()
                wItem.questId = v.questId
                wItem.questStatus  = v.questStatus
                wItem.questProcess = v.questProcess
                local hasItem =  TaskFunctionData:GetWeekendTaskOfKey(wItem.questId)
                if hasItem  ~= nil  then
                    hasItem.questStatus =   wItem.questStatus
                    hasItem.questProcess =  wItem.questProcess
                else        
                    self:PutWeekendTaskItem(wItem)
                end
            end 
            for k,v in pairs ( data.data.questData.dayQuestList )  do 
                local dItem =  DayTaskItem.New()
                dItem.questId = v.questId
                dItem.questStatus  = v.questStatus
                dItem.questProcess = v.questProcess
                local hasItem =  TaskFunctionData:GetDayTaskOfKey(dItem.questId)
                if hasItem  ~= nil  then
                    hasItem.questStatus =   dItem.questStatus
                    hasItem.questProcess =  dItem.questProcess
                else
                    self:PutDayTaskItem(dItem)
                end
            end     
            self.questListUpdateTime = data.data.questData.questListUpdateTime
        end
    else 
       -- print("当前发过来的任务数据 是空的 =========================================================")
    end
end 
--刷新相关任务
function  TaskFunctionData.ChangeTaskData()
   
    local taskType = InitDataProtocalManager.PROTOCOL_274 
    local param = JsonObject.New();
    local beforeQuestId = TaskFunctionData.lastLookAdsTaskId 
   
    local questFlag =  TaskFunctionData:CurTaskIsDayOrWeekendOfKey(TaskFunctionData.lastLookAdsTaskId)
    local taskDicItemType = 0
   if questFlag == 1 then
          taskDicItemType =  TaskFunctionData:GetDayTaskOfKey(beforeQuestId):GetDicTaskItem():GetTaskType()

   else 
          taskDicItemType =  TaskFunctionData:GetWeekendTaskOfKey(beforeQuestId):GetDicTaskItem():GetTaskType()
   end
    param:encode("questFlag",questFlag)
    param:encode("beforeQuestId",beforeQuestId) 
    local hasAd = UserDataManager.IsChannelHasAd();
    local costType =2
     if hasAd  then
        costType = 1
      GzTK.TKEventOfValue(TalkingDataConst.TKE_ADS_REFRESH_TASK_ID,beforeQuestId.."");
      GzTK.TKEventOfValue(TalkingDataConst.TKE_ADS_REFRESH_TASK_TYPE,taskDicItemType.."");
     else 
        costType = 2
         GzTK.TKEventOfValue(TalkingDataConst.TKE_DIAMOND_REFRESH_TASK_ID,beforeQuestId.."");
        GzTK.TKEventOfValue(TalkingDataConst.TKE_DIAMOND_REFRESH_TASK_TYPE,taskDicItemType.."");
     end
    param:encode("costType",costType) 
    local luaClass = "TaskFunctionData"
    local luaFun = "RefreshCurTask"
    GzNet.Call(taskType,param,luaClass,luaFun)
    UIManager.showLoading(true)
end 
--刷新任务的协议回调
function  TaskFunctionData.RefreshCurTask(_netdata)
       UIManager.showLoading(false)
       if _netdata ~=nil then
            local data = tools_Cjson.decode (_netdata._data)
            if data.data ~= nil  then
                -- print("当前bushi 空 =================")
               
                --任务的id
                local beforeQuestId =  data.data.beforeQuestId
               
                --任务的类型 是  1是日任务 2是周任务
                local  questFlag = data.data.questFlag
                --刷新后的任务对象
                local afterQuest = data.data.afterQuest
                 TaskFunctionData.isAdd = data.data.isAdReport
               --  print(" data.data.isAdReport".. data.data.isAdReport)
              --   print( data.data.isAdReport  == 1)
             --    print( data.data.isAdReport == "1")
                if afterQuest ~= nil then
                         local hasAd = UserDataManager.IsChannelHasAd();
                          if hasAd  then
                                 GzTK.TKEvent(TalkingDataConst.TKE_REFRESH_TASK_OF_ADS)
                          else 
                                 GzTK.TKEvent(TalkingDataConst.TKE_REFRESH_TASK_OF_DIAMOND)
                                 UserDataManager.Instance.DiamondNum = data.data.finalNum
                          end
                      if questFlag == 2 then
                            local  newTaskItem = WeekendTaskItem.New()
                            newTaskItem.questId = afterQuest.questId
                            newTaskItem.questStatus = afterQuest.questStatus
                            newTaskItem.questProcess = afterQuest.questProcess
                            if ViewQuestPanel.gameObject ~= nil then
                               ViewQuestPanel.RfreshOneWeekendTask(beforeQuestId,newTaskItem)
                            end
                      elseif  questFlag == 1 then
                            
                            
                            local  newTaskItem = DayTaskItem.New()
                            newTaskItem.questId = afterQuest.questId
                            newTaskItem.questStatus = afterQuest.questStatus
                            newTaskItem.questProcess = afterQuest.questProcess
                            if ViewQuestPanel.gameObject ~= nil then
                                ViewQuestPanel.RefreshOneDayTask(beforeQuestId,newTaskItem)
                            end 
                            -- local taskItem =  TaskFunctionData:GetDayTaskOfKey(beforeQuestId)  
                            -- taskItem.questId = afterQuest.questId
                            -- taskItem.questStatus = afterQuest.questStatus
                            -- taskItem.questProcess = afterQuest.questProcess
                      end
                       TipsManager.Instance:showTipOnce(LanguageManager.Instance:getLanguageByTID("refresh_task_sucess"), Vector3.New(0, UnityEngine.Screen.height / 10 * 2, 0))
                end
            else  
                  TipsManager.Instance:showTipOnce(LanguageManager.Instance:getLanguageByTID("refresh_task_failed"), Vector3.New(0, UnityEngine.Screen.height / 10 * 2, 0))
            end
       end
end 
--第一次广告上报
function TaskFunctionData.SendAdsDataFirst( )
    -- body
         if UserDataManager.IsChannelHasAd() then
             local taskType = NetConfig.HttpTaskType.HttpTaskType_Look_Ads
            local param = JsonObject.New();
            param:encode("isAdd",0)
            local luaClass = "TaskFunctionData"
            local luaFun = "GetIsSendAds"
            GzNet.Call(taskType,param,luaClass,luaFun)
         end
        
end
--广告协议上报
function TaskFunctionData.SendAdsData()
  --  print("TaskFunctionData.SendAdsData()TaskFunctionData.SendAdsData()TaskFunctionData.SendAdsData()============================isAdd"..TaskFunctionData.isAdd)
  --  print(TaskFunctionData.isAdd == 1)
  --  print(TaskFunctionData.isAdd == "1")
  --  print(tonumber(TaskFunctionData.isAdd) == 1)
    if tonumber(TaskFunctionData.isAdd)  == 1 then
          local taskType = NetConfig.HttpTaskType.HttpTaskType_Look_Ads
          local param = JsonObject.New();
          param:encode("isAdd",TaskFunctionData.isAdd)
          local luaClass = "TaskFunctionData"
          local luaFun = "GetIsSendAds"
        --  print("TaskFunctionData.SendAdsData()TaskFunctionData.SendAdsData()TaskFunctionData.SendAdsData()===================1111111=========isAdd"..TaskFunctionData.isAdd)
          GzNet.Call(taskType,param,luaClass,luaFun)
    end
end 
function TaskFunctionData.GetIsSendAds(_netdata)
         if _netdata ~=nil then
                local data = tools_Cjson.decode (_netdata._data)
                if data.data ~= nil  then
                 --   print(" TaskFunctionData.GetIsSendAds(_netdata)======================= TaskFunctionData.GetIsSendAds(_netdata)============== TaskFunctionData.GetIsSendAds(_netdata)-=-=-=-=-=-="..data.data.isContinueReport)
                 TaskFunctionData.isAdd = data.data.isContinueReport
              --   print(" data.data.isContinueReport".. data.data.isContinueReport)
              --   print( data.data.isContinueReport == 1)
                -- print( data.data.isContinueReport == "1" )
                end 
         end
        
end 

--周任务子项
WeekendTaskItem = {}

function WeekendTaskItem.New()
    local item = {}
    setmetatable(item,WeekendTaskItem)
    WeekendTaskItem.__index = WeekendTaskItem
    --任务Id
    item.questId = 0;
    --任务状态   0未完成  1 已完成
    item.questStatus = 0
    --任务当前的进度值
    item.questProcess = 0
     
    return  item 
end 

--任务的id
function WeekendTaskItem:GetKey()

    return self.questId
end 
--当前任务是否完成
function WeekendTaskItem:GetTaskSta()
    return self.questStatus == TaskFunctionData.STA_TASK_OVER
end 
--获得常量信息
function WeekendTaskItem:GetDicTaskItem()
    return  QuestTaskDicSystem:GetTasksOfTaskId(self:GetKey())
end 
--日任务子项
DayTaskItem = {}

function DayTaskItem.New()
    local item = {}
    setmetatable(item,DayTaskItem)
    DayTaskItem.__index = DayTaskItem
    --任务Id
    item.questId = 0
    --任务状态  0是未完成 1 已完成
    item.questStatus = 0
    --任务进度值
    item.questProcess = 0
    return  item 
end 
--任务的Key
function DayTaskItem:GetKey()
    return self.questId
end
--当前任务是否完成
function DayTaskItem:GetTaskSta()
    return self.questStatus == TaskFunctionData.STA_TASK_OVER
end 
--获得常量信息
function DayTaskItem:GetDicTaskItem()
    return  QuestTaskDicSystem:GetTasksOfTaskId(self:GetKey())
end 