﻿--任务进度界面的视图管理
ViewQuestPanel = {}
--标题
ViewQuestPanel.titleLb = nil
--关闭按钮
ViewQuestPanel.closeBtn = nil
--每日任务的界面
ViewQuestPanel.dayTasksParent = nil 
--每周任务的界面
ViewQuestPanel.weekendTasksParent = nil 
--当前是第几个赛季
ViewQuestPanel.whichGameLb = nil 
--当前的对位名称
ViewQuestPanel.dwName = nil 
--当前段位对应的图片
ViewQuestPanel.dwSp = nil 
--当前拥星星的数量
ViewQuestPanel.curStarNums = nil 
--下一个阶段的描述
ViewQuestPanel.nextDesc = nil 
--当前星星的 进度 
ViewQuestPanel.curDwStarNum = nil 
--当前阶段的进度
ViewQuestPanel.curdwProgress = nil 
--当前阶段奖励显示sp=
ViewQuestPanel.curRewardSp = nil 
--当前阶段的 英雄sp
ViewQuestPanel.heroSp = nil
--当前Ian阶段奖励 是金币 
ViewQuestPanel.coinSp = nil
--每日任务的标题
ViewQuestPanel.dayTasksTitleLb = nil 
--需要生成的任务子项
ViewQuestPanel.taskItemGo = nil 
--每周任务的标题
ViewQuestPanel.weekendTitleLb = nil 

ViewQuestPanel.gameObject = nil 

--周任务的视图管理项列表
ViewQuestPanel.viewWeekendTaskLst = {}
--每日任务的视图管理列表
ViewQuestPanel.viewDayTaskLst = {}
--刷新时间
ViewQuestPanel.refreshTime = nil 
--打开 排位奖励界面
ViewQuestPanel.openRewardPanelBtn = nil 

function  ViewQuestPanel.Awake(go)
        ViewQuestPanel.gameObject = go
        ViewQuestPanel:InitUI()
            
end 

function ViewQuestPanel.Start()
  --  print("ViewQuestPanel.Start()ViewQuestPanel.Start()======ViewQuestPanel.Start()===========================")
    --清空播放广告失败数据
     GzAdEventSta.Instance():clearFail();    
     ViewQuestPanel:RefreshDayTasks()
     ViewQuestPanel:RefreshWeekendTasks()
     ViewQuestPanel:RefreshLeftStars()
    local curTime  = os.date("%x")
    local curHour = os.date("*t", os.time()).hour 
    local str = curTime..","..curHour..","
    local lastTime  = UnityEngine.PlayerPrefs.SetString(ViewLoginPanel.writeBigEffectTime,str)
    UnityEngine.PlayerPrefs.SetInt(ViewLoginPanel.isCLickTaskPanel,1)
    ViewLoginPanel.ShowBigEffect()
    --  print("ViewQuestPanel.Start()ViewQuestPanel.Start()111111111111111111111111111111=================")
end 

--初始化UI
function   ViewQuestPanel:InitUI()
        ViewQuestPanel.titleLb  = self.gameObject.transform:Find("allGo/titleBg/titleLb"):GetComponent("UILabel")
        ViewQuestPanel.curStarNums  = self.gameObject.transform:Find("allGo/titleBg/curStars/nums"):GetComponent("UILabel")
        ViewQuestPanel.closeBtn = self.gameObject.transform:Find("allGo/closeBtn").gameObject
        ViewQuestPanel.dayTasksParent = self.gameObject.transform:Find("allGo/dayTasks/ScrollView").gameObject
        ViewQuestPanel.weekendTasksParent = self.gameObject.transform:Find("allGo/weekendTasks/ScrollView").gameObject
        ViewQuestPanel.whichGameLb  = self.gameObject.transform:Find("allGo/titleBg/whichGame"):GetComponent("UILabel")
        ViewQuestPanel.dwName = self.gameObject.transform:Find("allGo/dwbotton/dwName"):GetComponent("UILabel")
        ViewQuestPanel.dwSp = self.gameObject.transform:Find("allGo/dwbotton/dwTex"):GetComponent("UISprite")
        ViewQuestPanel.nextDesc = self.gameObject.transform:Find("allGo/dwbotton/bottonProgress/nextDec"):GetComponent("UILabel")
        ViewQuestPanel.curDwStarNum  = self.gameObject.transform:Find("allGo/dwbotton/bottonProgress/nums"):GetComponent("UILabel")
        ViewQuestPanel.curdwProgress  = self.gameObject.transform:Find("allGo/dwbotton/bottonProgress/progressBg"):GetComponent("UISlider")
        ViewQuestPanel.dayTasksTitleLb = self.gameObject.transform:Find("allGo/dayTasks/title"):GetComponent("UILabel")
        ViewQuestPanel.curRewardSp =  self.gameObject.transform:Find("allGo/dwbotton/bottonProgress/reward/prop"):GetComponent("UISprite")
        ViewQuestPanel.heroSp=  self.gameObject.transform:Find("allGo/dwbotton/bottonProgress/reward/hero"):GetComponent("UISprite")
        ViewQuestPanel.coinSp = self.gameObject.transform:Find("allGo/dwbotton/bottonProgress/reward/coinSp"):GetComponent("UISprite")
        ViewQuestPanel.taskItemGo = self.gameObject.transform:Find("allGo/taskItem").gameObject
        ViewQuestPanel.weekendTitleLb =  self.gameObject.transform:Find("allGo/weekendTasks/title"):GetComponent("UILabel")
        UIEventListener.Get( ViewQuestPanel.closeBtn).onClick = function()  ViewQuestPanel:CloseViewQuestPanel()  end 
        ViewQuestPanel.titleLb.text  =  Lua_LanguageManager.GetContentOfID("quest_title")
        ViewQuestPanel.nextDesc.text = Lua_LanguageManager.GetContentOfID("li_next_reward")
        ViewQuestPanel.dayTasksTitleLb.text =  Lua_LanguageManager.GetContentOfID("every_day_task")
        ViewQuestPanel.weekendTitleLb.text =   Lua_LanguageManager.GetContentOfID("every_week_task")
        ViewQuestPanel.whichGameLb.text = "S"..QualifyRewardVarDataManager:GetCurSeasonNum()
        ViewQuestPanel.refreshTime = self.gameObject.transform:Find("allGo/back/refreshTime"):GetComponent("UILabel")
         ViewQuestPanel.refreshTime.text = Lua_LanguageManager.GetContentOfID("task_refresh_time")
         ViewQuestPanel.openRewardPanelBtn  = self.gameObject.transform:Find("allGo/dwbotton/bottonProgress").gameObject
          UIEventListener.Get( ViewQuestPanel.openRewardPanelBtn).onClick = function()  ViewQuestPanel:OpenRewardPanel()  end 
end 
--打开奖励 界面
function  ViewQuestPanel:OpenRewardPanel()
     UIManager.PopUI()
     if(InitDataProtocalManager.IsSyncFinished()) then
        GzTK.TKEvent(TalkingDataConst.TKE_OPEN_REWARD_PANEL_FROM_TASK);
        UIManager.CreateUIOfLua("QualifyRewardPanel")
     end
end  
--关闭按钮的点击事件
function  ViewQuestPanel:CloseViewQuestPanel()
           UIManager. PopUI()
           EventDispatcher.instance:InvokeEvent(EventNameList.eEventRefreshHomeGlodAndDiamond)
end 
--刷新日任务列表
function    ViewQuestPanel:RefreshDayTasks()
    local allDayTaskDataLst = TaskFunctionData:GetAllDayTasks()
    ViewQuestPanel.viewDayTaskLst = {}
  --  print("allDayTaskDataLstallDayTaskDataLstallDayTaskDataLstallDayTaskDataLst"..#allDayTaskDataLst)
    for k,v  in pairs(allDayTaskDataLst)  do
         local dayItemGo = NGUITools.AddChild(ViewQuestPanel.dayTasksParent,ViewQuestPanel.taskItemGo)
         local viewTaskItem  = ViewTaskItem.New(dayItemGo)
         viewTaskItem.gameObject.transform.localPosition = Vector3.New(69,50-(k-1)*96,0);
          viewTaskItem.gameObject:SetActive(true)
         viewTaskItem.gameObject.name = "viewTaskItem"..k
         table.insert( ViewQuestPanel.viewDayTaskLst,viewTaskItem )
         viewTaskItem:SetTaskItem(v)
         viewTaskItem:RefreshUI()
    end
end 
--刷新周任务列表
function ViewQuestPanel:RefreshWeekendTasks()
      local allWeekendTaskDataLst = TaskFunctionData:GetAllWeekendTasks()
      ViewQuestPanel.viewWeekendTaskLst = {}
    --  print("allWeekendTaskDataLstallWeekendTaskDataLstallWeekendTaskDataLstallWeekendTaskDataLst"..#allWeekendTaskDataLst)
    for k,v  in pairs(allWeekendTaskDataLst)  do
         local dayItemGo = NGUITools.AddChild(ViewQuestPanel.weekendTasksParent,ViewQuestPanel.taskItemGo)
         local viewTaskItem  = ViewTaskItem.New(dayItemGo)
         viewTaskItem.gameObject.transform.localPosition = Vector3.New(39,50-(k-1)*96,0);
          viewTaskItem.gameObject:SetActive(true)         
         viewTaskItem.gameObject.name = "viewTaskItem"..k
         table.insert( ViewQuestPanel.viewWeekendTaskLst, viewTaskItem )
         viewTaskItem:SetTaskItem(v)
         viewTaskItem:RefreshUI()
    end
end 
--刷新 日任务中的 某一个 任务
function  ViewQuestPanel.RefreshOneDayTask(questId,taskItem)
   --- print("asadasdasdasd--刷新 日任务中的 某一个 任务=========================")
    for  k,v  in pairs( ViewQuestPanel.viewDayTaskLst) do 
         --   print("v:GetTaskVarId()v:GetTaskVarId()v:GetTaskVarId()=================-------"..v:GetTaskVarId())
             if questId == v:GetTaskVarId() then
             --   print("asadasdasdasd--刷新 日任务中的 某一个 任务====================1111111111111111111111=====")
              local  taskVarItem = TaskFunctionData:GetDayTaskOfKey(questId)
              v:SetTaskItem(taskItem)
              v:RefreshUI()
              taskVarItem.questId = taskItem.questId
              taskVarItem.questStatus = taskItem.questStatus
              taskVarItem.questProcess = taskItem.questProcess
              break 
        end
    end 
end 
--刷新 周任务中的 某一个 任务
function ViewQuestPanel.RfreshOneWeekendTask(questId,taskItem)
    for k,v in pairs(ViewQuestPanel.viewWeekendTaskLst) do
        if questId == v:GetTaskVarId() then
              local  taskVarItem = TaskFunctionData:GetWeekendTaskOfKey(questId)
              v:SetTaskItem(taskItem)
              v:RefreshUI()
              taskVarItem.questId = taskItem.questId
              taskVarItem.questStatus = taskItem.questStatus
              taskVarItem.questProcess = taskItem.questProcess
              break
        end
    end
end 
--刷新 左侧的星星的界面
function ViewQuestPanel:RefreshLeftStars()

          local  score = UserDataManager.Instance.QualifyingScore
        --  print("scorescorescorescorescore|||||||||||||||||||||||||||||"..score)
         -- local  qualifyingData = QualifyingDataManager.Instance.GetSegment(score);
        --  local index= qualifyingData.index
          ViewQuestPanel.dwSp.spriteName =QualifyingDataManager.Instance.GetSpName()
          local str1 = QualifyingDataManager.Instance.GetCurQualifyName()
       
          ViewQuestPanel.dwName.text = str1


    --     print("========7897897897897897897897897987897897897===============================")
        ViewQuestPanel.curStarNums.text  = Lua_LanguageManager.GetContentOfID("cur_star_num")..QualifyRewardVarDataManager:GetCurStarProcess()
        
        if  QualifyRewardDataManager:GetNextRewardItem() ~= nil then 
          --  print("2312312312312312312312312323132132123123123123123123212312323123123123112123231231231231312231231")
           --  print(" QualifyRewardVarDataManager:GetCurStarProcess()/QualifyRewardDataManager:GetNextRewardItem().needCount"..(QualifyRewardVarDataManager:GetCurStarProcess()/QualifyRewardDataManager:GetNextRewardItem().needCount))
            ViewQuestPanel.curdwProgress .value = (QualifyRewardVarDataManager:GetCurStarProcess() -QualifyRewardDataManager:GetCurOverRewardItemStars())/(QualifyRewardDataManager:GetNextRewardItem().needCount- QualifyRewardDataManager:GetCurOverRewardItemStars())
           -- ViewQuestPanel.curdwProgress .value = (QualifyRewardDataManager:GetNextRewardItem().needCount-QualifyRewardVarDataManager:GetCurStarProcess())/(QualifyRewardDataManager:GetNextRewardItem().needCount- QualifyRewardDataManager:GetCurOverRewardItemStars())
            ViewQuestPanel.curDwStarNum.text = (QualifyRewardVarDataManager:GetCurStarProcess() -QualifyRewardDataManager:GetCurOverRewardItemStars()).."/"..(QualifyRewardDataManager:GetNextRewardItem().needCount- QualifyRewardDataManager:GetCurOverRewardItemStars())
            local rewardStr = QualifyRewardDataManager:GetNextRewardStr()
            local   data = string.split(rewardStr,":");
            local  propId = tonumber(data[1]);
            local   propNum = tonumber(data[2]);
            local  rewardItem = PropDicDataManager.Instance:getPropDicItemOfKey(propId);
            local  propName = self.gameObject.transform:Find("allGo/dwbotton/bottonProgress/propName"):GetComponent("UILabel")
            if  QualifyRewardDataManager:GetNextRewardItem().type ~= 2 then 
                if  rewardItem ~=  nil then 
                   
                  
                    if rewardItem.propType == Lua_ActivityConst.SKIN_ROLE_TYPE then--是英雄
                         -- ViewQuestPanel.curRewardSp.spriteName = rewardItem.propSprite
                        propName.text=Lua_LanguageManager.GetContentOfID("skin_name_"..propId);
                        ViewQuestPanel.heroSp.gameObject:SetActive(true)
                         ViewQuestPanel.heroSp:SetDimensions(254,254)
                        ViewQuestPanel.heroSp.spriteName = rewardItem.propSprite
                    elseif rewardItem.propType == Lua_ActivityConst.HEAD_BORDER_PROP_TYPE then--是头像框
                        propName.text=Lua_LanguageManager.GetContentOfID("border_name_"..propId);
                        ViewQuestPanel.curRewardSp.gameObject:SetActive(true);
                        local borderData = HeadBorderDataManager:GetBorderDataById(rewardItem.propId);
                        --设置头像框的图集和图片
                        HeadBorderDataManager.SetSpriteByBorderId(ViewQuestPanel.curRewardSp,borderData.headId)   
                    else
                        if propId == 401 then
                             ViewQuestPanel.coinSp.gameObject:SetActive(true)
                        else 
                             ViewQuestPanel.curRewardSp.gameObject:SetActive(true);
                        end
                        GzLoadAtlasManager.Instance:SetAtlasAndSprite( ViewQuestPanel.curRewardSp, "heroHead", rewardItem.propSprite);
                        propName.text=propNum..Lua_LanguageManager.GetContentOfID("exchange_item_"..propId);
                    end
                      
                else  
                   --  print("物品表中并没有 当前 propId ======="..propId.."的物品")
                end 
            else
                    GzLoadAtlasManager.Instance:SetAtlasAndSprite( ViewQuestPanel.curRewardSp, "heroHead", "box");
                    ViewQuestPanel.curRewardSp.gameObject:SetActive(true);
                    propName.text = Lua_LanguageManager.GetContentOfID("qualify_reward_box_name")
            end 

            
        else 

     --   print("获得 下一个奖励的内容 为空==============**********************************")
        end 
        
        
end

function ViewQuestPanel.OnDestroy()

end  
--子项任务的视图管理
ViewTaskItem = {}

function ViewTaskItem.New(go)
    local item = {}
    setmetatable(item, ViewTaskItem)
    ViewTaskItem.__index = ViewTaskItem
    item.taskDec = nil --任务的描述
    item.progressNum = nil --  任务当前的进度值
    item.progressSlider = nil --  任务当前的进度条
    item.starNums = nil  --完成当前任务可以得到的星星的数量
    item.gameObject = go
    item.taskVarItem = nil
    item.back = nil 
    item.frontProgressSp = nil 
    item.lookAdBtn = nil  --看广告按钮
    item.overLb = nil  --已完成
    item:InitUI()
    return  item 
end 

--初始化UI
function  ViewTaskItem:InitUI()
    self.taskDec  =  self.gameObject.transform:Find("desc"):GetComponent("UILabel")
    self.progressNum= self.gameObject.transform:Find("progressNum"):GetComponent("UILabel")
    self.progressSlider =  self.gameObject.transform:Find("progressBar"):GetComponent("UISlider")
    self.starNums = self.gameObject.transform:Find("Star/nums"):GetComponent("UILabel")
    self.back = self.gameObject.transform:GetComponent("UISprite")
    self.frontProgressSp = self.gameObject.transform:Find("progressBar/Sprite"):GetComponent("UISprite")
    self.lookAdBtn = self.gameObject.transform:Find("refreshBtn").gameObject
    self.overLb = self.gameObject.transform:Find("over"):GetComponent("UILabel")
    UIEventListener.Get( self.lookAdBtn).onClick = function()  self:LookAdLogic() end 
end 
--看广告逻辑
function ViewTaskItem:LookAdLogic()
      TaskFunctionData.lastLookAdsTaskId  =  self:GetTaskVarId() 
     -- TaskFunctionData.ChangeTaskData() 
       local hasAd = UserDataManager.IsChannelHasAd();
       if hasAd  then
            --adEvent:SetClickAdVideo(ViewQuestPanel.gameObject.name);

            Lua_AdsManager.PlayVedioAdvertise(ViewQuestPanel.gameObject.name,GzAdParam.GetParamOfTask())
       else 
            if UserDataManager.Instance.DiamondNum < 10 then
                 TipsManager.Instance:showTipOnce(LanguageManager.Instance:getLanguageByTID("refresh_task_of_diamond_fail"), Vector3.New(0, UnityEngine.Screen.height / 10 * 2, 0))
            else 
                 TaskFunctionData.ChangeTaskData()    
            end
       end 
end
-- 设置任务Id
function ViewTaskItem:SetTaskItem(taskVarItem)
    self.taskVarItem  = taskVarItem
end 
--获得任务Id
function  ViewTaskItem:GetTaskVarId()
     --   print("ViewTaskItem:GetTaskVarId()=================".. self.taskVarItem.questId)
        return  self.taskVarItem.questId
end 
-- 获得任务常量
function ViewTaskItem:GetDicItem()
    return QuestTaskDicSystem:GetTasksOfTaskId(self.taskVarItem.questId)
end 
--显示UI
function ViewTaskItem:RefreshUI()
    self.taskDec.text = self:GetDicItem():GetShowText() -- Lua_LanguageManager.GetContentOfID(self:GetDicItem().dec)
    self.progressNum.text =   self.taskVarItem.questProcess.."/".. self:GetDicItem().require
    self.progressSlider.value =  self.taskVarItem.questProcess/self:GetDicItem().require
    self.starNums.text =  self:GetDicItem().star
    if self.taskVarItem.questStatus ==  TaskFunctionData.STA_TASK_OVER then
        self.back.spriteName = "task_011"
        self.frontProgressSp.spriteName = "task_012"
        self.taskDec.color = Color.New(144/255,71/255,2/255)
        self.progressNum.color =  Color.New(144/255,71/255,2/255)
        self.lookAdBtn .gameObject:SetActive(false)
        self.overLb.gameObject:SetActive(true)
         self.overLb.text = Lua_LanguageManager.GetContentOfID("task_is_over")
    else 
        self.back.spriteName = "task_008"
        self.frontProgressSp.spriteName = "task_009"
        self.taskDec.color = Color.New(103/255,103/255,103/255)
        self.progressNum.color =  Color.New(103/255,103/255,103/255)
        self.lookAdBtn .gameObject:SetActive(true)
        self.overLb.gameObject:SetActive(false)
    end
    local hasAd = UserDataManager.IsChannelHasAd();
    if hasAd then
        self.lookAdBtn.gameObject.transform:Find("ad").gameObject:SetActive(true)
        self.lookAdBtn.gameObject.transform:Find("diamond").gameObject:SetActive(false)
        
        local desc = self.lookAdBtn.gameObject.transform:Find("ad/free"):GetComponent("UILabel")
        desc.text = Lua_LanguageManager.GetContentOfID("free_to_refresh_task")
    else 
         self.lookAdBtn.gameObject.transform:Find("diamond").gameObject:SetActive(true)
         self.lookAdBtn.gameObject.transform:Find("ad").gameObject:SetActive(false)
          local desc = self.lookAdBtn.gameObject.transform:Find("diamond/desc"):GetComponent("UILabel")
          local num = self.lookAdBtn.gameObject.transform:Find("diamond/Label"):GetComponent("UILabel")
          num.text = "10"
         desc.text = Lua_LanguageManager.GetContentOfID("diamond_refresh_task")
    end
end



