
Example_Package = {}

Example_Package.pathName = "example_package"


-- 导入一个 相对 Main_Package.theProjectPath 的路径下的路径 及名字
function requireClass(path, name)
	require( path.."/"..name)
end



--导入某个组
function Example_Package.requireLogic(item)
    for i,itemName in ipairs(item.itemList) do
        requireClass(item.itemPath,itemName)
    end
end


-- 这里是一个组的内容  整个包会有N个组
Example_Package.packageClass={
    itemList={
        "Example_1",
        "Example_2",
        "Example_3",
    },
    -- 相于对 Main_Package.theProjectPath 后的路径
    itemPath = Main_Package.theProjectPath..Example_Package.pathName
}


--这里是所有的组
Example_Package.packageList = 
{
    Example_Package.packageClass
}


-- 导入所有
function Example_Package.requireAllPackage()
	for i, pv in ipairs(Example_Package.packageList) do
		--print("pv.nameList.count"..#pv.nameList)
		Example_Package.requireLogic(pv);
	end
end