﻿--迁移账号的视图管理
MoveUserPanel= {}

MoveUserPanel.gameObject = nil 

--初始界面  
MoveUserPanel.firstPanel = nil 
--移动其他设备按钮
MoveUserPanel.moveToOtherMobileBtn = nil 
MoveUserPanel.moveToOtherMobileLb = nil
-- 移动到这台设备的按钮
MoveUserPanel.moveToThisMobileBtn = nil 
MoveUserPanel.moveToThisMobileLb = nil 


--设置迁移密码 的界面
MoveUserPanel.setMoveNumberPanel  = nil
--设置迁移密码的 输入密码框
MoveUserPanel.setMoveNumberInput  = nil
--设置迁移密码的确定按钮 
MoveUserPanel.setMoveNumberBesureBtn = nil


--选择密保问题界面
MoveUserPanel.chooseQuestionPanel = nil


-- 移动到当前的手机账号界面
MoveUserPanel.moveToThisMobilePanel = nil 
-- 移动到当前的手机账号的 结果 失败 或是成功的界面
MoveUserPanel.moveUserDataResoult = nil

-- 输入转移密码界面
MoveUserPanel.inputMoveNumPanel = nil 
--忘记密码接口面
MoveUserPanel.forgetNumberPanel = nil 
--当前选择问题的index 
MoveUserPanel.questionIndex = 0

MoveUserPanel.questionLst = {"move_question_1","move_question_2","move_question_3"}

function MoveUserPanel.Awake(go)
    MoveUserPanel.gameObject  = go
end

function MoveUserPanel.Start()
    MoveUserPanel:InitAllUI()
    -- local aa = "aaaa"..InitDataProtocalManager.releaseVer
    -- local  a = UserDataManager.Instance:UserMd5(aa)
   -- print("MoveUserPanel.Start()=========="..a)
end 
--初始化当前的UI 
function  MoveUserPanel:InitAllUI()
  --  print("  MoveUserPanel:InitAllUI()================")
    --初始化 初始UI 
    self:InitFristPanelUI()
    -- 初始化密保问题界面
    self:InitChooseQuestionUI()
    --初始化设定密码UI
    self:InitSetPassWordUI()
    --初始化移动到当前手机的界面
    self:InitMoveToCurPanelUI()
    -- 初始化忘记密码界面
    self:InitForgetPassWordPanelUI()
    --初始化输入转移密码界面
    self:InitInputMoveNumPanelUI()
    --初始化 显示自己密码的界面
    self:InitShowSelfPassWordUI()
    -- 初始化转移结果界面
    self:InitMoveResaultPanelUI()
end
--初始化移动账号的第一个界面
function  MoveUserPanel:InitFristPanelUI()
    MoveUserPanel.firstPanel = self.gameObject.transform:Find("FristPanel").gameObject
    MoveUserPanel.moveToOtherMobileBtn  = self.gameObject.transform:Find("FristPanel/Btn1").gameObject
    MoveUserPanel.moveToOtherMobileLb  =  MoveUserPanel.moveToOtherMobileBtn.transform:Find("Label"):GetComponent("UILabel")
    UIEventListener.Get( MoveUserPanel.moveToOtherMobileBtn).onClick = function()  MoveUserPanel:MoveToOtherMobileLogic()  end 
    MoveUserPanel.moveToThisMobileBtn = self.gameObject.transform:Find("FristPanel/Btn2").gameObject
    MoveUserPanel.moveToThisMobileLb  =  MoveUserPanel.moveToThisMobileBtn.transform:Find("Label"):GetComponent("UILabel")
    UIEventListener.Get( MoveUserPanel.moveToThisMobileBtn).onClick = function()  MoveUserPanel:MoveToThisMoblieLoigc()  end 
    MoveUserPanel.firstPanelCloseBtn = self.gameObject.transform:Find("FristPanel/closeBtn").gameObject
    UIEventListener.Get( MoveUserPanel.firstPanelCloseBtn).onClick = function()  MoveUserPanel:CloseFristPanelLogic()  end 
    MoveUserPanel.moveToOtherMobileLb.text =  LanguageManager.Instance:getLanguageByTID("move_to_other_mobile")--"转移到其他设备"
    MoveUserPanel.moveToThisMobileLb.text = LanguageManager.Instance:getLanguageByTID("move_to_this_mobile")--"转移到这台设备"
end 
--初始界面的关闭按钮逻辑
function MoveUserPanel:CloseFristPanelLogic()
    MoveUserPanel:ClosePanel()
end 
--移动其他设备按钮点击事件
function MoveUserPanel:MoveToOtherMobileLogic()
   -- print(" MoveUserPanel:MoveToOtherMobileLogic()================")
   -- print(UserMoveData:GetIsMovedUser())
     MoveUserPanel.firstPanel:SetActive(false)
    -- 设置过转移密码
    if  UserMoveData:GetIsMovedUser() then
        MoveUserPanel.inputMoveNumPanel:SetActive(true);
    --输入界面
        MoveUserPanel.inputPanel:SetActive(true);
    else -- 没有设置过转移密码
        MoveUserPanel.setMoveNumberPanel:SetActive(true)
    end

end 
--移动到这台设备按钮的点击事件
function MoveUserPanel:MoveToThisMoblieLoigc()
    MoveUserPanel.firstPanel:SetActive(false)
    MoveUserPanel.moveToThisMobilePanel:SetActive(true)
end 

--初始化 设定密码的界面
function MoveUserPanel:InitSetPassWordUI()
    MoveUserPanel.setMoveNumberPanel  = self.gameObject.transform:Find("SetMoveNumberPanel").gameObject
    MoveUserPanel.setPassWordDesc1 = self.gameObject.transform:Find("SetMoveNumberPanel/back/desc1"):GetComponent("UILabel")
    MoveUserPanel.setPassWordDesc2 = self.gameObject.transform:Find("SetMoveNumberPanel/back/desc2"):GetComponent("UILabel")

    MoveUserPanel.setMoveNumberInput = self.gameObject.transform:Find("SetMoveNumberPanel/inputLb"):GetComponent("UIInput")

    MoveUserPanel.setMoveNumberBesureBtn = self.gameObject.transform:Find("SetMoveNumberPanel/beSureBtn").gameObject
    MoveUserPanel.beSureLb = self.gameObject.transform:Find("SetMoveNumberPanel/beSureBtn/Label"):GetComponent("UILabel")
    UIEventListener.Get( MoveUserPanel.setMoveNumberBesureBtn).onClick = function()  MoveUserPanel:BeSureToSetPwBtnLogic()  end 
    MoveUserPanel.setMoveNumberPanelCloseBtn =  self.gameObject.transform:Find("SetMoveNumberPanel/closeBtn").gameObject
    UIEventListener.Get( MoveUserPanel.setMoveNumberPanelCloseBtn).onClick = function()  MoveUserPanel:CloseSetMoveNumberPanel()  end 


    MoveUserPanel.setPassWordDesc1.text = LanguageManager.Instance:getLanguageByTID("do_not_set_password")-- "还未设定迁移密码，请输入"
    MoveUserPanel.setPassWordDesc2.text=  LanguageManager.Instance:getLanguageByTID("by_six_number")--"密码由6位数字组成"
    MoveUserPanel.beSureLb .text= LanguageManager.Instance:getLanguageByTID("button_confirm")
end
function  MoveUserPanel:CloseSetMoveNumberPanel()  
    MoveUserPanel.setMoveNumberPanel:SetActive(false)
    MoveUserPanel.firstPanel:SetActive(true)
end 
--确定设置密码的按钮
function MoveUserPanel:BeSureToSetPwBtnLogic()
    --print(" string.len( MoveUserPanel.setMoveNumberInput.value )".. string.len( MoveUserPanel.setMoveNumberInput.value ))
    if string.len( MoveUserPanel.setMoveNumberInput.value )  ~= 6 then
        -- body
        TipsManager.Instance:showTipOnce( LanguageManager.Instance:getLanguageByTID("input_six_number_please"), Vector3.New(0, UnityEngine.Screen.height / 10 * 2, 0))
        return 
    end
    MoveUserPanel.setMoveNumberPanel:SetActive(false)
    MoveUserPanel.chooseQuestionPanel:SetActive(true)
    MoveUserPanel.questionsPanel:SetActive(true)
end 
-- 初始化密保问题界面
function MoveUserPanel:InitChooseQuestionUI()
    MoveUserPanel.chooseQuestionPanel =   self.gameObject.transform:Find("chooseQuestionPanel").gameObject
    --选择问题界面
    MoveUserPanel.questionsPanel =  self.gameObject.transform:Find("chooseQuestionPanel/questions").gameObject
    MoveUserPanel.chooseQuestionDesc = self.gameObject.transform:Find("chooseQuestionPanel/questions/back/Label"):GetComponent("UILabel")
    MoveUserPanel.chooseQuestionDesc .text = LanguageManager.Instance:getLanguageByTID("choose_question_index")--"请选择密保问题"
    for   i= 1,3 do 
            local questionsGo =  MoveUserPanel.questionsPanel .transform:Find("questionBtn"..i).gameObject
            --TODO 设置密码问题来源  ==  文字相关
            local lb = questionsGo.transform:Find("Label"):GetComponent("UILabel")
            lb.text = LanguageManager.Instance:getLanguageByTID(MoveUserPanel.questionLst[i])
            UIEventListener.Get(questionsGo).onClick = function()  MoveUserPanel:ChooseOneQuestionBtnLogic(i)  end 
    end     
    MoveUserPanel.questionsPanelCloseBtn =   self.gameObject.transform:Find("chooseQuestionPanel/questions/closeBtn").gameObject
    UIEventListener.Get(MoveUserPanel.questionsPanelCloseBtn).onClick = function()  MoveUserPanel:CloseQuestionPanel()  end 
    -- 设置答案界面
    MoveUserPanel.setAnswerPanel = self.gameObject.transform:Find("chooseQuestionPanel/setAnswer").gameObject
    MoveUserPanel.inputQuestionAnswer =   MoveUserPanel.setAnswerPanel.transform:Find("inputAnswer"):GetComponent("UIInput")
    MoveUserPanel.chooseQuestionBeSureBtn  = MoveUserPanel.setAnswerPanel.transform:Find("beSureBtn").gameObject
    MoveUserPanel.chooseQuestionBeSureBtnLb=  MoveUserPanel.chooseQuestionBeSureBtn .transform:Find("Label"):GetComponent("UILabel")
    UIEventListener.Get( MoveUserPanel.chooseQuestionBeSureBtn).onClick = function()  MoveUserPanel:BeSureToSetAnswerBtnLogic()  end 
    MoveUserPanel.chooseQuestionBeSureBtnLb.text = LanguageManager.Instance:getLanguageByTID("button_confirm")
    MoveUserPanel.setAnswerPanelCloseBtn = self.gameObject.transform:Find("chooseQuestionPanel/setAnswer/closeBtn").gameObject
    UIEventListener.Get( MoveUserPanel.setAnswerPanelCloseBtn).onClick = function()  MoveUserPanel:CloseSetAnswerPanel()  end 

    -- 设置密保问题成功或者失败界面
    MoveUserPanel.setQuestionResaultPanel = self.gameObject.transform:Find("chooseQuestionPanel/setMoveNumSuccess").gameObject
    --设置密保问题成功描述
    MoveUserPanel.setQuestionResaultDesc = self.gameObject.transform:Find("chooseQuestionPanel/setMoveNumSuccess/desc"):GetComponent("UILabel")
    --设置密保问题成功界面关闭按钮
    MoveUserPanel.closeBtnOfSetQuestionResault = self.gameObject.transform:Find("chooseQuestionPanel/setMoveNumSuccess/closeBtn").gameObject
    UIEventListener.Get( MoveUserPanel.closeBtnOfSetQuestionResault).onClick = function()  MoveUserPanel:CloseSetQustionResaultPanel()  end 
    --设置 密保问题成功界面的 获得迁移码按钮
    MoveUserPanel.getMoveNumBtn =  self.gameObject.transform:Find("chooseQuestionPanel/setMoveNumSuccess/beSureBtn").gameObject
    UIEventListener.Get( MoveUserPanel.getMoveNumBtn).onClick = function()  MoveUserPanel:GetMoveNumLogic()  end 
    --设置密保问题的 获得转移码 按钮的描述
    MoveUserPanel.getMoveNumBtnDesc = self.gameObject.transform:Find("chooseQuestionPanel/setMoveNumSuccess/beSureBtn/Label"):GetComponent("UILabel")
    MoveUserPanel.getMoveNumBtnDesc.text = LanguageManager.Instance:getLanguageByTID("get_move_number") --"获取迁移码"
    MoveUserPanel.setQuestionResaultDesc.text = LanguageManager.Instance:getLanguageByTID("success_to_set_password")-- "已经成功设定迁移密码"


    -- 获得迁移码界面
    MoveUserPanel.getMoveNumPanel = self.gameObject.transform:Find("chooseQuestionPanel/getMoveWordPanel").gameObject
    -- 迁移码显示
    MoveUserPanel.moveNumLb =   self.gameObject.transform:Find("chooseQuestionPanel/getMoveWordPanel/back/moveDesc"):GetComponent("UILabel")
    --获得迁移码界面的关闭按钮
    MoveUserPanel.closeBtnInGetMoveNumPanel =  self.gameObject.transform:Find("chooseQuestionPanel/getMoveWordPanel/closeBtn").gameObject
    UIEventListener.Get( MoveUserPanel.closeBtnInGetMoveNumPanel).onClick = function()  MoveUserPanel:CloseMoveNumPanel()  end 
    --获得迁移码界面的 描述
    MoveUserPanel.getMoveNumDesc = self.gameObject.transform:Find("chooseQuestionPanel/getMoveWordPanel/DescBack/desc"):GetComponent("UILabel")

    MoveUserPanel.getMoveNumDesc.text = LanguageManager.Instance:getLanguageByTID("move_num_over_desc")--"请在设备上输入以上迁移码，即可完成账号迁移，改迁移码2分钟有效，如果过期需要重新获取。"
end 
function MoveUserPanel:CloseQuestionPanel() 
    MoveUserPanel.setMoveNumberPanel:SetActive(true)
    MoveUserPanel.chooseQuestionPanel:SetActive(false)
    MoveUserPanel.questionsPanel:SetActive(false)
end 
function  MoveUserPanel:CloseSetAnswerPanel() 
    MoveUserPanel:ClosePanel()
end 
--选择了某一密保问题的 按钮
function MoveUserPanel:ChooseOneQuestionBtnLogic(index)

      --  print("点击了 =======第"..index.."个问题")
        MoveUserPanel.questionIndex  = index
        MoveUserPanel.questionsPanel:SetActive(false)
        MoveUserPanel.setAnswerPanel:SetActive(true)
end 
--确定 设置密保问题的 的确定按钮点击事件
function MoveUserPanel:BeSureToSetAnswerBtnLogic()
   --     print("确定设置了密保问题的 的答案 ：".. MoveUserPanel.inputQuestionAnswer.value)

        local protocalNum  = 302   --协议号
        local param = JsonObject.New()
        local password = MoveUserPanel.setMoveNumberInput.value
      --   local sendMd5 = UserDataManager.Instance:UserMd5(password)
        param:encode("password",password)
        local passwordProtect =MoveUserPanel.inputQuestionAnswer.value
      --  local sendMd5Answer = UserDataManager.Instance:UserMd5(passwordProtect)
        param:encode("passwordProtect",passwordProtect)
        param:encode("protectQuestion",MoveUserPanel.questionIndex.."")
        local token =  UserDataManager.Instance:UserMd5_Second()
        param:encode("token",token)
        local luaClass = "MoveUserPanel"
        local luaFun = "BeSureToSetAnswerBtnLogicBackCall"
        GzNet.Call(protocalNum,param,luaClass,luaFun)
        UIManager.showLoading(true)

       
end 
function MoveUserPanel. BeSureToSetAnswerBtnLogicBackCall(_netdata)
    UIManager.showLoading(false)
    if _netdata ~=nil then
        local data = tools_Cjson.decode (_netdata._data)
            if data.code == 0  then
            
                    MoveUserPanel.setAnswerPanel:SetActive(false)
                    MoveUserPanel.setQuestionResaultPanel:SetActive(true)
                    UserMoveData.passwordFlag  = "1"
            else
                    GzTK.TKEvent (TalkingDataConst.TKE_SET_QUESITON_FAILED);
                    TipsManager.Instance:showTipOnce(LanguageManager.Instance:getLanguageByTID("set_failed_try_again"), Vector3.New(0, UnityEngine.Screen.height / 10 * 2, 0))
            end 
    end 
end 
--获得 迁移码 按钮的点击事件
function  MoveUserPanel:GetMoveNumLogic()


    local protocalNum  = 300    --协议号
    local param = JsonObject.New()
    local passWord =  MoveUserPanel.setMoveNumberInput.value
    local sendMd5 = UserDataManager.Instance:UserMd5(passWord)
    param:encode("password",sendMd5)
    local luaClass = "MoveUserPanel"
    local luaFun = "GetMoveNumLogicCallBack"
    GzNet.Call(protocalNum,param,luaClass,luaFun)
    UIManager.showLoading(true)
   
end
function MoveUserPanel.GetMoveNumLogicCallBack(_netdata)
    UIManager.showLoading(false)
    MoveUserPanel.setQuestionResaultPanel:SetActive(false)
    MoveUserPanel.getMoveNumPanel:SetActive(true)
    if _netdata ~=nil then
      --  print(" _netdata ~=nil  =================")
        local data = tools_Cjson.decode (_netdata._data)
            if data.data ~= nil  then
            --   print("data.data ~= nil============")
             --  print("data.data.token==========="..data.data.token)
                MoveUserPanel.moveNumLb.text= data.data.token
            end 
    end
end 
--关闭设置密保成功界面
function  MoveUserPanel:CloseSetQustionResaultPanel()  
    MoveUserPanel:ClosePanel() 
end 
--关闭 获得迁移码界面
function MoveUserPanel:CloseMoveNumPanel()
   -- MoveUserPanel.chooseQuestionPanel:SetActive(false)
    MoveUserPanel.getMoveNumPanel:SetActive(false)
    MoveUserPanel:ClosePanel() 
end 
--初始化移动到当前手机的界面
function MoveUserPanel:InitMoveToCurPanelUI()
    MoveUserPanel.moveToThisMobilePanel  = self.gameObject.transform:Find("moveToThisMobile").gameObject
   
    MoveUserPanel.moveToThisMobilePanelDesc1 =  self.gameObject.transform:Find("moveToThisMobile/back/desc"):GetComponent("UILabel")
    MoveUserPanel.moveToThisMobilePanelDesc2 =  self.gameObject.transform:Find("moveToThisMobile/userIdBack/desc"):GetComponent("UILabel")

    MoveUserPanel.moveToThisMobileInputLb = self.gameObject.transform:Find("moveToThisMobile/inputLb"):GetComponent("UIInput")

    MoveUserPanel.moveToThisMobileInputUserId = self.gameObject.transform:Find("moveToThisMobile/inputUserId"):GetComponent("UIInput")

    MoveUserPanel.closeBtnOfMoveToThisMobile = self.gameObject.transform:Find("moveToThisMobile/closeBtn").gameObject

    UIEventListener.Get( MoveUserPanel.closeBtnOfMoveToThisMobile).onClick = function()  MoveUserPanel:CloseMoveToThisMobile()  end 

    MoveUserPanel.beSureBtnOfMoveToThisMobile = self.gameObject.transform:Find("moveToThisMobile/beSureBtn").gameObject
    UIEventListener.Get( MoveUserPanel.beSureBtnOfMoveToThisMobile).onClick = function()  MoveUserPanel:BeSureToMoveUserId()  end 
    MoveUserPanel.beSureLbOfMoveToThisMobile = self.gameObject.transform:Find("moveToThisMobile/beSureBtn/Label"):GetComponent("UILabel")

    MoveUserPanel.moveToThisMobilePanelDesc1.text = LanguageManager.Instance:getLanguageByTID("input_move_number_desc1")--"请输入转移码,转移码来自原设备"
    MoveUserPanel.moveToThisMobilePanelDesc2.text = LanguageManager.Instance:getLanguageByTID("input_move_number_desc2")--"请输入用户ID,在原手机设置中查看"
    MoveUserPanel.beSureLbOfMoveToThisMobile.text = LanguageManager.Instance:getLanguageByTID("button_confirm")
end 
--关闭移动到当前手机界面
function  MoveUserPanel:CloseMoveToThisMobile()
    MoveUserPanel.moveToThisMobilePanel:SetActive(false)
    MoveUserPanel.firstPanel:SetActive(true)
end

-- 移动当前手机的确定按钮的点击逻辑
function  MoveUserPanel:BeSureToMoveUserId()  
   -- print("移动当前手机的确定按钮的点击逻辑===================")
    local protocalNum  = 301   --协议号
    local param = JsonObject.New()
    local token =  MoveUserPanel.moveToThisMobileInputLb.value
    param:encode("token",token)
    local oldUserId = MoveUserPanel.moveToThisMobileInputUserId.value
    param:encode("oldUserId",oldUserId)
    local luaClass = "MoveUserPanel"
    local luaFun = "BeSureToMoveUserIdCallBack"
    GzNet.Call(protocalNum,param,luaClass,luaFun)
    UIManager.showLoading(true)
end

function  MoveUserPanel.BeSureToMoveUserIdCallBack(_netdata)
      UIManager.showLoading(false)
      -- 如果转移码正确
      MoveUserPanel.moveToThisMobilePanel:SetActive(false)
      MoveUserPanel.moveUserDataResoult:SetActive(true)
      if _netdata ~=nil then
        local data = tools_Cjson.decode (_netdata._data)
        if data.code == 0 then 
            if data.data ~= nil  then
                MoveUserPanel.moveUserDataResoultDesc.text = LanguageManager.Instance:getLanguageByTID("move_user_success")--"恭喜账号转移成功，请重新打开游戏"
                UIEventListener.Get( MoveUserPanel.moveUserDataResoultCloseBtn).onClick = function()   MoveUserPanel:CloseMoveSuccessPanel(1)  end 
                GzTK.TKEvent (TalkingDataConst.TKE_MOVE_USER_SUCCESS);
            end
        else
            MoveUserPanel.moveUserDataResoultDesc.text = LanguageManager.Instance:getLanguageByTID("move_failed_try_input")--"转移失败，请正确输入" 
            UIEventListener.Get( MoveUserPanel.moveUserDataResoultCloseBtn).onClick = function()   MoveUserPanel:CloseMoveSuccessPanel(0)  end 
        end 
    end 
end 

--初始化输入转移密码界面
function MoveUserPanel:InitInputMoveNumPanelUI()
    MoveUserPanel.inputMoveNumPanel =  self.gameObject.transform:Find("inputMoveNumber").gameObject

    --输入界面
    MoveUserPanel.inputPanel = self.gameObject.transform:Find("inputMoveNumber/inputPanel").gameObject
    MoveUserPanel.inputPanelDesc = self.gameObject.transform:Find("inputMoveNumber/inputPanel/back/Label"):GetComponent("UILabel")
    MoveUserPanel.inputPassWrod = self.gameObject.transform:Find("inputMoveNumber/inputPanel/inputPassWrod"):GetComponent("UIInput")
    MoveUserPanel.beSureBtnOfInputMoveNumPanel = self.gameObject.transform:Find("inputMoveNumber/inputPanel/beSureBtn").gameObject
    MoveUserPanel.beSureLbOfInputMoveNumPanel = self.gameObject.transform:Find("inputMoveNumber/inputPanel/beSureBtn/Label"):GetComponent("UILabel")
    UIEventListener.Get( MoveUserPanel.beSureBtnOfInputMoveNumPanel).onClick = function()  MoveUserPanel:BeSureInputMovePasswordLogic()  end 
    MoveUserPanel.forgetNumBtn =  self.gameObject.transform:Find("inputMoveNumber/inputPanel/forgetPassWordBtn").gameObject
    MoveUserPanel.forgetNumLb =  self.gameObject.transform:Find("inputMoveNumber/inputPanel/forgetPassWordBtn/Label"):GetComponent("UILabel")
    UIEventListener.Get( MoveUserPanel.forgetNumBtn).onClick = function()  MoveUserPanel:OpenForgetNumPanel()  end 
    MoveUserPanel.inputPanelCloseBtn  =  self.gameObject.transform:Find("inputMoveNumber/inputPanel/closeBtn").gameObject
    UIEventListener.Get( MoveUserPanel.inputPanelCloseBtn).onClick = function()  MoveUserPanel:CloseInputPanelLoigc()  end 
    -- 输入密码结果
    MoveUserPanel.inputResultPanel = self.gameObject.transform:Find("inputMoveNumber/inputResultPanel").gameObject
    MoveUserPanel.inputResultPanelDesc = self.gameObject.transform:Find("inputMoveNumber/inputResultPanel/bcak/desc"):GetComponent("UILabel")
    MoveUserPanel.inputResultPanelCode = self.gameObject.transform:Find("inputMoveNumber/inputResultPanel/bcak/resault"):GetComponent("UILabel")
    MoveUserPanel.inputResultPanelBeSureBtn = self.gameObject.transform:Find("inputMoveNumber/inputResultPanel/bcak/besureBtn").gameObject
    MoveUserPanel.inputResultPanelBeSureBtnLb = self.gameObject.transform:Find("inputMoveNumber/inputResultPanel/bcak/besureBtn/Label"):GetComponent("UILabel")
    UIEventListener.Get( MoveUserPanel.inputResultPanelBeSureBtn).onClick = function()  MoveUserPanel:OpenInputPanel()  end 

    MoveUserPanel.beSureLbOfInputMoveNumPanel .text = LanguageManager.Instance:getLanguageByTID("button_confirm")
    MoveUserPanel.inputPanelDesc.text= LanguageManager.Instance:getLanguageByTID("input_move_word")--"请输入转移密码"
    MoveUserPanel.forgetNumLb.text = LanguageManager.Instance:getLanguageByTID("forget_move_num")--"忘记密码"
    MoveUserPanel.inputResultPanelDesc.text = LanguageManager.Instance:getLanguageByTID("password_wrong")-- "密码错误"
    MoveUserPanel.inputResultPanelBeSureBtnLb.text= LanguageManager.Instance:getLanguageByTID("button_confirm")

end 
--关闭输入迁移密码界面
function MoveUserPanel:CloseInputPanelLoigc() 
    MoveUserPanel.inputMoveNumPanel:SetActive(false)
    MoveUserPanel.firstPanel:SetActive(true)
end 
--输入密码错误之后的确定按钮的点击事件
function  MoveUserPanel:OpenInputPanel() 
    MoveUserPanel.inputPanel:SetActive(true)
    MoveUserPanel.inputResultPanel:SetActive(false)
end 
--输入密码界面的确定按钮
function  MoveUserPanel:BeSureInputMovePasswordLogic() 


    local protocalNum  = 300    --协议号
    local param = JsonObject.New()
    local passWord =  MoveUserPanel.inputPassWrod.value
    local sendMd5 = UserDataManager.Instance:UserMd5(passWord)
    param:encode("password", sendMd5)
    local luaClass = "MoveUserPanel"
    local luaFun = "BeSureInputMovePasswordLogicCallBack"
    GzNet.Call(protocalNum,param,luaClass,luaFun)
    UIManager.showLoading(true)
end 
function  MoveUserPanel.BeSureInputMovePasswordLogicCallBack(_netdata)
    UIManager.showLoading(false)
    if _netdata ~=nil then
        local data = tools_Cjson.decode (_netdata._data)
        if data.code == 0 then 
            if data.data ~= nil  then
                     --如果密码正确 
                MoveUserPanel.inputPanel:SetActive(false)
                MoveUserPanel.chooseQuestionPanel:SetActive(true)
                MoveUserPanel.getMoveNumPanel:SetActive(true)
                MoveUserPanel.moveNumLb.text= data.data.token
            end 
        elseif  data.code == -2018  then   -- 账号密码错误
            TipsManager.Instance:showTipOnce(LanguageManager.Instance:getLanguageByTID("user_word_wrong"), Vector3.New(0, UnityEngine.Screen.height / 10 * 2, 0))
            MoveUserPanel.inputPanel:SetActive(false)
            MoveUserPanel.inputResultPanel:SetActive(true)
            if tonumber(data.data.remaining)  < 5 then
                MoveUserPanel.inputResultPanelCode.text =  LanguageManager.Instance:getLanguageByTID("five_wrong_over")--"请重新输入密码，只有5次错误的机会，5次错误 24小时内不能重新尝试，你也可以选择重新设置密码"
            else    
                MoveUserPanel.inputResultPanelCode.text = LanguageManager.Instance:getLanguageByTID("please_24h_try_again")--"请24小时后重新再试"
            end
        elseif  data.code == -2017  then  --账号密码已冻结
            TipsManager.Instance:showTipOnce( LanguageManager.Instance:getLanguageByTID("user_word_dongjie"), Vector3.New(0, UnityEngine.Screen.height / 10 * 2, 0))
        elseif  data.code == -2015  then --尚未登记密码
            TipsManager.Instance:showTipOnce( LanguageManager.Instance:getLanguageByTID("shang_wei_dengji_mima"), Vector3.New(0, UnityEngine.Screen.height / 10 * 2, 0))
        elseif  data.code == -2020  then --账号近期已经迁移过
            TipsManager.Instance:showTipOnce( LanguageManager.Instance:getLanguageByTID("zhanghao_qianyi_guo"), Vector3.New(0, UnityEngine.Screen.height / 10 * 2, 0))
        end 
    end 
end 

--忘记密码按钮点击事件  button_confirm
function  MoveUserPanel:OpenForgetNumPanel() 
    MoveUserPanel.inputPanel:SetActive(false)
    MoveUserPanel.forgetNumberPanel:SetActive(true)
    MoveUserPanel.questionDesc.text = LanguageManager.Instance:getLanguageByTID(MoveUserPanel.questionLst[UserMoveData:GetQuestionIndex ()])
end
--初始化忘记密码界面UI
function  MoveUserPanel:InitForgetPassWordPanelUI()
    MoveUserPanel.forgetNumberPanel = self.gameObject.transform:Find("forgetNumberPanel").gameObject
    MoveUserPanel.forgetNumberPanelDesc = self.gameObject.transform:Find("forgetNumberPanel/title/Label"):GetComponent("UILabel")

    MoveUserPanel.questionBackInput = self.gameObject.transform:Find("forgetNumberPanel/questionBack"):GetComponent("UIInput")
    MoveUserPanel.questionDesc = self.gameObject.transform:Find("forgetNumberPanel/questionBack/questionLb"):GetComponent("UILabel")
    MoveUserPanel.forgetNumberPanelBeSureBtn =  self.gameObject.transform:Find("forgetNumberPanel/beSureBtn").gameObject

    MoveUserPanel.forgetNumberPanelBeSureBtnLb =  self.gameObject.transform:Find("forgetNumberPanel/beSureBtn/Label"):GetComponent("UILabel")
    UIEventListener.Get( MoveUserPanel.forgetNumberPanelBeSureBtn).onClick = function()  MoveUserPanel:GetPassWordLogic()  end 

    MoveUserPanel.forgetNumberPanelCloseBtn =  self.gameObject.transform:Find("forgetNumberPanel/closeBtn").gameObject
    UIEventListener.Get( MoveUserPanel.forgetNumberPanelCloseBtn).onClick = function()  MoveUserPanel:CloseForgetNumberPanel()  end 

    MoveUserPanel.forgetNumberPanelDesc.text = LanguageManager.Instance:getLanguageByTID("answer_question")--"回答密码问题"
    MoveUserPanel.forgetNumberPanelBeSureBtnLb .text= LanguageManager.Instance:getLanguageByTID("button_confirm")
end 

function MoveUserPanel:CloseForgetNumberPanel() 
    MoveUserPanel.forgetNumberPanel:SetActive(false)
    MoveUserPanel.inputPanel:SetActive(true)
end 
--获得自己的密码
function MoveUserPanel:GetPassWordLogic()


    local protocalNum  = 303   --协议号
    local param = JsonObject.New()
    local passwordProtect =  MoveUserPanel.questionBackInput.value
    local sendMD5 =  UserDataManager.Instance:UserMd5(passwordProtect)
    param:encode("passwordProtect",sendMD5)
    local protectQuestion = UserMoveData.protectQuestion
    param:encode("protectQuestion",protectQuestion)
    local luaClass = "MoveUserPanel"
    local luaFun = "GetPassWordLogicCallBack"
    GzNet.Call(protocalNum,param,luaClass,luaFun)
    UIManager.showLoading(true)
end 
function MoveUserPanel.GetPassWordLogicCallBack(_netdata)
    UIManager.showLoading(false)
    MoveUserPanel.forgetNumberPanel:SetActive(false)
    MoveUserPanel.forgetNumShowPanel:SetActive(true)
    if _netdata ~= nil  then
        local data = tools_Cjson.decode (_netdata._data)
        if data.code == 0 then 
            if data.data ~= nil  then
                MoveUserPanel.forgetNumShowPanelDesc.text = LanguageManager.Instance:getLanguageByTID("answer_current")--"回答正确"
                MoveUserPanel.forgetNumShowPanelYourNum.text  = LanguageManager.Instance:getLanguageByTID("your_num_is").. data.data.password
                UIEventListener.Get( MoveUserPanel.forgetNumShowPanelBeSureBtn).onClick = function()  MoveUserPanel:ForgetNumShowPanelClosePanel(1)  end 
            end 
        else
            MoveUserPanel.forgetNumShowPanelDesc.text = LanguageManager.Instance:getLanguageByTID("answer_wrong")--"回答错误"
            MoveUserPanel.forgetNumShowPanelYourNum.text = LanguageManager.Instance:getLanguageByTID("please_try_answer_question") --"请重新回答密保问题"
            UIEventListener.Get( MoveUserPanel.forgetNumShowPanelBeSureBtn).onClick = function()  MoveUserPanel:ForgetNumShowPanelClosePanel(0)  end 
        end 
    end
end 

--初始化 显示自己密码的界面
function MoveUserPanel:InitShowSelfPassWordUI()
    MoveUserPanel.forgetNumShowPanel = self.gameObject.transform:Find("forgetNumShowPanel").gameObject
    MoveUserPanel.forgetNumShowPanelDesc = self.gameObject.transform:Find("forgetNumShowPanel/title/Label"):GetComponent("UILabel")
    MoveUserPanel.forgetNumShowPanelYourNum =  self.gameObject.transform:Find("forgetNumShowPanel/back/passward"):GetComponent("UILabel")
    MoveUserPanel.forgetNumShowPanelBeSureBtn =  self.gameObject.transform:Find("forgetNumShowPanel/beSureBtn").gameObject
   

end
function MoveUserPanel:ForgetNumShowPanelClosePanel(index)
    MoveUserPanel.forgetNumShowPanel :SetActive(false)
    if index ==  1 then 
        MoveUserPanel.inputMoveNumPanel:SetActive(true)
        MoveUserPanel.inputPanel :SetActive(true)
    else 
        MoveUserPanel.forgetNumberPanel:SetActive(true)
    end 
end 
--关闭界面 
function MoveUserPanel:ClosePanel() 
    UIManager. PopUI()
end 
-- 初始化转移结果界面
function MoveUserPanel:InitMoveResaultPanelUI()
    MoveUserPanel.moveUserDataResoult = self.gameObject.transform:Find("moveUserDataResoult").gameObject
    MoveUserPanel.moveUserDataResoultDesc =  self.gameObject.transform:Find("moveUserDataResoult/back/desc"):GetComponent("UILabel")
    MoveUserPanel.moveUserDataResoultCloseBtn =  self.gameObject.transform:Find("moveUserDataResoult/back/closeBtn").gameObject
    UIEventListener.Get( MoveUserPanel.moveUserDataResoultCloseBtn).onClick = function()   MoveUserPanel:CloseMoveSuccessPanel()  end 

    -- MoveUserPanel.moveUserDataResoultBeSureBtn = self.gameObject.transform:Find("moveUserDataResoult/back/besureBtn").gameObject
    -- UIEventListener.Get( MoveUserPanel.moveUserDataResoultBeSureBtn).onClick = function()   MoveUserPanel:BeSureOfmoveUserDataResoultLogic()  end 
end 
-- function  MoveUserPanel:BeSureOfmoveUserDataResoultLogic() 
--     MoveUserPanel.moveUserDataResoult:SetActive(false)
--     MoveUserPanel
-- end 
--转移结果界面的 关闭按钮
function  MoveUserPanel:CloseMoveSuccessPanel(flag)
    if flag == 0 then
        --转移错误
        MoveUserPanel.moveUserDataResoultDesc.text = LanguageManager.Instance:getLanguageByTID("move_cuo_shuru_again")--"转移码错误，请重新输入"
        MoveUserPanel.moveUserDataResoult:SetActive(false)
        MoveUserPanel.moveToThisMobilePanel:SetActive(true)
    elseif flag ==1 then
        -- 转移码正确
        MoveUserPanel.moveUserDataResoultDesc.text = LanguageManager.Instance:getLanguageByTID("move_success_open_game_again")
        MoveUserPanel.moveUserDataResoult:SetActive(false)
        MoveUserPanel:ClosePanel() 
        UnityEngine.Application.Quit()
    end
end